;******************************************************************************
;*                                                                            *
;*  BasLink.asm                                                               *
;*  DS Software Authorization SDK 4.31                                        *
;*  Disk 1 - Dos Object & Source Files                                        *
;*  07/09/98                                                                  *
;*                                                                            *
;*  Copyright (C) 1994, 1996,1997, 1998 Dallas Semiconductor Corporation.     *
;*  All rights Reserved. Printed in U.S.A.                                    *
;*  This software is protected by copyright laws of                           *
;*  the United States and of foreign countries.                               *
;*  This material may also be protected by patent laws of the United States   *
;*  and of foreign countries.                                                 *
;*  This software is furnished under a license agreement and/or a             *
;*  nondisclosure agreement and may only be used or copied in accordance      *
;*  with the terms of those agreements.                                       *
;*  The mere transfer of this software does not imply any licenses            *
;*  of trade secrets, proprietary technology, copyrights, patents,            *
;*  trademarks, maskwork rights, or any other form of intellectual            *
;*  property whatsoever. Dallas Semiconductor retains all ownership rights.   *
;*                                                                            *
;*  Additional Notes:                                                         *
;*                                                                            *
;*     This module was assembled using version 6.11 MASM.  Other assemblers   *
;*     may require some modification of the source code, depending on the     *
;*     implementation.                                                        *
;*                                                                            *
;******************************************************************************
;
; Baslink (linkage code for Microsoft Quickbasic Ver 4.5)
;
code       segment    para
           assume     cs:code
;
           public     bsetup
           public     bfirst
           public     bnext
           public     baccess
           public     bdatabyte
           public     bromdata
           public     bgndtest
           public     bkeyopen
           public     bkeyclose
           public     bdowcheck
           public     boverdriveon
           public     boverdriveoff
;
           extrn      setup : near
           extrn      first : near
           extrn      next  : near
           extrn      access : near
           extrn      databyte : near
           extrn      romdata : near
           extrn      gndtest : near
           extrn      keyopen : near
           extrn      keyclose : near
           extrn      dowcheck : near
           extrn      overdriveon : near
           extrn      overdriveoff : near

;
bdowcheck  proc       far
           push       bp                
           mov        bp, sp            
           push       cs
           call       near ptr dowcheck
           mov        bx, 6[bp]
           mov        [bx], ax
           mov        sp, bp
           pop        bp
           ret        2
bdowcheck  endp
;
bkeyopen   proc       far
           push       bp
           mov        bp, sp
           push       cs
           call       near ptr keyopen
           mov        bx, 6[bp]
           mov        [bx], ax
           mov        sp, bp
           pop        bp
           ret        2
bkeyopen   endp
;
bkeyclose  proc       far
           push       bp
           mov        bp, sp
           push       cs
           call       near ptr keyclose
           mov        bx, 6[bp]
           mov        [bx], ax
           mov        sp, bp
           pop        bp
           ret        2
bkeyclose  endp
;
boverdriveon proc     far
            push      bp
            mov       bp, sp
            push      cs
            call      near ptr overdriveon
            mov       bx, 6[bp]
            mov       [bx], ax
            mov       sp, bp
            pop       bp
            ret       2
boverdriveon endp
;
boverdriveoff proc    far
            push      bp
            mov       bp, sp
            push      cs
            call      near ptr overdriveoff
            mov       bx, 6[bp]
            mov       [bx], ax
            mov       sp, bp
            pop       bp
            ret       2
boverdriveoff endp
;
bsetup     proc       far
           push       bp                ; Save the bp register.
           mov        bp, sp            ; Put stack pointer in bp.
           mov        bx, 8[bp]         ; Get address of pn in bx.
           mov        ax, [bx]          ; Put pn in ax
           push       ax                ; Pass pn as parameter to setup.
           push       cs
           call       near ptr Setup
           mov        bx, 6[bp]         ; Point to location of ans% on stack.
           mov        [bx], ax          ; Store address of result on stack.
           mov        sp, bp            ; Restore stack pointer.
           pop        bp                ; Restore bp register.
           ret        4
bsetup     endp
;
bfirst     proc       far
           push       bp
           mov        bp, sp
           push       cs
           call       near ptr first
           mov        bx, 6[bp]
           mov        [bx], ax
           mov        sp, bp
           pop        bp
           ret        2
bfirst     endp
;
bnext      proc       far
           push       bp
           mov        bp, sp
           push       cs
           call       near ptr next
           mov        bx, 6[bp]
           mov        [bx], ax
           mov        sp, bp
           pop        bp
           ret        2
bnext      endp
;
baccess    proc       far
           push       bp
           mov        bp, sp
           push       cs
           call       near ptr access
           mov        bx, 6[bp]
           mov        [bx], ax
           mov        sp, bp
           pop        bp
           ret        2
baccess    endp
;
bdatabyte  proc       far
           push       bp
           mov        bp, sp
           mov        bx, 8[bp]
           mov        ax, [bx]
           push       ax
           push       cs
           call       near ptr databyte
           mov        bx, 6[bp]
           mov        [bx], ax
           mov        sp, bp
           pop        bp
           ret        4
bdatabyte  endp
;
bromdata   proc       far
           push       bp
           mov        bp, sp
           push       cs
           call       near ptr romdata
           mov        bx, 8[bp]
           mov        [bx], dx          ; Put segment on stack.
           mov        bx, 6[bp]
           mov        [bx], ax          ; Put offset on stack.
           mov        sp, bp
           pop        bp
           ret        4
bromdata   endp
;
bgndtest   proc       far
           push       bp
           mov        bp, sp
           push       cs
           call       near ptr gndtest
           mov        bx, 6[bp]
           mov        [bx], ax
           mov        sp, bp
           pop        bp
           ret        2
bgndtest   endp
;
code       ends
           end
