/* ************************************************************************* */
/* Number.c                                                                  */ 
/* Diag_16.c                                                                 */
/* DS Software Authorization SDK 4.3                                         */
/* Disk 1 - Dos Object & Source Files                                        */
/* 02/13/98                                                                  */
/*                                                                           */
/* Copyright (C) 1996 Dallas Semiconductor Corporation.                      */
/* All rights Reserved. Printed in U.S.A.                                    */
/* This software is protected by copyright laws of                           */
/* the United States and of foreign countries.                               */
/* This material may also be protected by patent laws of the United States   */
/* and of foreign countries.                                                 */
/* This software is furnished under a license agreement and/or a             */
/* nondisclosure agreement and may only be used or copied in accordance      */
/* with the terms of those agreements.                                       */
/* The mere transfer of this software does not imply any licenses            */
/* of trade secrets, proprietary technology, copyrights, patents,            */
/* trademarks, maskwork rights, or any other form of intellectual            */
/* property whatsoever. Dallas Semiconductor retains all ownership rights.   */
/*                                                                           */
/* Additional Notes:                                                         */
/*                                                                           */
/*    This software is intended for use with DS1410D and DS1410E and later   */
/*    model parallel port adapters only.                                     */
/*                                                                           */
/* ************************************************************************* */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

typedef unsigned char byte;

byte far pascal setup(byte);
byte far pascal first(void);
byte far pascal next(void);
byte far pascal access(void);
byte far pascal gndtest(void);
byte far pascal databyte(byte);
byte far * far pascal romdata(void);
byte far pascal dowcheck(void);
byte far pascal keyopen(void);
byte far pascal keyclose(void);

#define FALSE 0
#define TRUE 1 

byte pn, part_num, i; 
byte far *romptr;

void main(int argc, char *argv[]) 
{ 
   if (argc > 1) 
   { 
      pn = atoi(argv[1]); 
   }
   else 
   {
      printf("Port number not specified, defaulting to 1\n");
      printf("Press any key to continue ...");

      while (!kbhit());

      if (!getch())
         getch();

      pn = 1;
   }
   if(dowcheck())
   {
      /* Initialize LPT port #pn */
      if (setup(pn))                             
      {
         if(keyopen())
         {
            /* Check if printer is on line */
            if (gndtest())                      
            {
               /* Find first DOW part on LPT port #pn */
					if (first())
					{
						clrscr();
						do
						{
							gotoxy(17, 5 + part_num++);

							/* romptr now points to ROM buffer */
							romptr = romdata();

							/* NOTE: the statement:             */
							/*                                  */
							/*       *romptr |= 0x80;           */
							/*                                  */
							/* can easily make legacy code able */
							/* to recognize newer iButtons by   */
							/* just adding one statement!       */

							if (*romptr == 0x81)
								printf("DS1420 SERIAL NUMBER ");
							else if (*romptr == 0x82)
								printf("DS1425 SOFTWARE KEY  ");
							else if (*romptr == 0x84)
								printf("DS1427 TIME KEY      ");
							else if (*romptr == 0x01)
								printf("DS1990 SOFTWARE KEY  ");
							else if (*romptr == 0x02)
								printf("DS1991 SOFTWARE KEY  ");
							else if (*romptr == 0x04)
								printf("DS1425 SOFTWARE KEY  ");

                     /* Point to byte 7 of serial number */
                     romptr = romptr + 7;  

                     for (i = 0; i < 8; i++) 
                        printf("%2.2X ", *romptr--);
                     printf("\n");
                  }
                  while (next());   /* Continue until all DOW parts found */

                  gotoxy(25, 7 + part_num);
                  printf("NUMBER OF PARTS ON LPT # %d = %d\n", pn, part_num);
               }
               else 
                  printf("No DOW parts found on LPT # %d", pn);
				}
            else 
               printf("Printer not on line\n");
         }
         keyclose();
      }
      else 
      {
         printf("LPT port # %d does not exist\n", pn);
      }
      
   } /* dowcheck */
}


