/*
   usesnum.c                                       { Ver 1.01 11/08/94 }
                                                   { Ver 1.02 06/20/96 }
   Copyright (C) 1996 Dallas Semiconductor Corporation. 
   All rights Reserved. Printed in U.S.A.
   This software is protected by copyright laws of
   the United States and of foreign countries.
   This material may also be protected by patent laws of the United States 
   and of foreign countries.
   This software is furnished under a license agreement and/or a
   nondisclosure agreement and may only be used or copied in accordance
   with the terms of those agreements.
   The mere transfer of this software does not imply any licenses
   of trade secrets, proprietary technology, copyrights, patents,
   trademarks, maskwork rights, or any other form of intellectual
   property whatsoever. Dallas Semiconductor retains all ownership rights.
*/

#include <stdio.h>
#include <stdlib.h>
#include <process.h>

typedef unsigned char byte;

byte far pascal setup(byte);
byte far pascal first(void);
byte far pascal next(void);
byte far pascal access(void);
byte far pascal gndtest(void);
byte far pascal databyte(byte);
byte far *far pascal romdata(void);
byte far pascal dowcheck(void);
byte far pascal keyopen(void);
byte far pascal keyclose(void);

byte crc8(int data);

byte far *romptr;
byte pn, j, crc, bv, cv;
FILE *fdes;

void main(int argc, char *argv[])
{
   if (argc > 1) pn = atoi(argv[1]); else pn = 1;
   if (dowcheck())
   {
      if (setup(pn))                              /* initialize LPT port #pn */
      {
         if (keyopen())                           /* get control of port */
         {
            if (gndtest())                        /* see if printer is on line */
            {
               if (first())                       /* search for first part on bus */
               {
                  do
                  {
                     fdes = fopen("DOWNUM.SNC", "r+b");   /* open file for number */
                     romptr = romdata();/* romptr points to eight byte ROM buffer */
                     crc = j = bv = cv = 0;
                     while ((j++ != 8) && (cv == bv))
                     {
                        bv = crc8(*romptr) ^ *romptr++;
                        fread(&cv, 1, 1, fdes);
                     }
                     if (j == 9)
                     {
                        printf("Desired security part successfully found\n");
                        fclose(fdes);
                        exit(0);
                     }
                     fclose(fdes);                       /* close file for number */
                  }
                  while (next());
               }
               else printf("No DOW parts on LPT port #%d\n", pn);         
            }
            else printf("Printer not on line\n");
         }
         else
            printf("failed keyopen\n");
         keyclose();                            /* release control of port */
      }
      else printf("Specified LPT port #%d does not exist\n", pn);
      printf("Security failure\n");
   }
}

static unsigned char crc;

byte crc8(int data)
{
   int i;
   int f;

   data = data & 0xff;

   for (i = 0; i < 8; ++i)
   {
      f    = 1 & (data ^ crc);
      crc  = crc  >> 1;
      data = data >> 1;
      if (f) crc = crc ^ 0x8c;
   }
   return crc;
}

