Program Number;   
{                                                                           }
{ Number.pas                                                                }
{ DS Software Authorization SDK 4.3                                         }
{ Disk 1 - Dos Object & Source Files                                        }
{ 02/06/98                                                                  }
{                                                                           }
{ Copyright (C) 1996 Dallas Semiconductor Corporation.  All rights          }
{ Reserved. Printed in U.S.A.  This software is protected by copyright laws }
{ of the United States and of foreign countries.  This software is          }
{ furnished under a license agreement and/or a nondisclosure agreement and  }
{ may only be used or copied in accordance with the terms of those          }
{ agreements.  The mere transfer of this software does not imply any        }
{ licenses of trade secrets, proprietary technology, copyrights, patents,   }
{ trademarks, maskwork rights, or any other form of intellectual            }
{ property whatsoever. Dallas Semiconductor retains all ownership rights.   }
{                                                                           }
{ Additional Notes:                                                         }
{                                                                           }
{      This code was compiled using Borland's Turbo Pascal 6.0 compiler.    }
{ Use of other compilers may require some changes to the source code.       }
{                                                                           }
{      This code is intended for use with Dallas Semiconductor parts        }
{ DS1410D and DS1410E parallel port adapters.                               }
{                                                                           }



Uses DOS, CRT, AccsysP;

Type
   RomAry = Array[1..8] of Byte;

Var
   PN, PartNum, I : Byte;
   RomPtr         : ^RomAry;
   RomDta         : RomAry;
   LI             : LongInt;
   Z              : Word;
   K              : Boolean;

Function Hex(X: Byte): String;
{                                                                           }
{  This function returns the hexadecimal representation string              }
{  of the byte passed to it.                                                }
{                                                                           }

Var
  S : String[2];
  I, J : Byte;

Begin { Function Hex }

  S := '';

  For I := 1 to 2 do Begin

     J := X and $F;
     X := X shr 4;
     If (J > 9) then
        Inc(J, 7);

     S := Char(J + $30) + S

  End;

  Hex := S;

End;  { Function Hex }

Begin { MAIN -------------------------------------------------------------- }

   PN := 1;                                        { Default to LPT port #1 }
   PartNum := 0;                                  { Zero parts found so far }

   If ParamCount > 0 then
   Begin
      {$R+}
      Val(ParamStr(1), LI, Z);
      {$R-}
      If (Z > 0) or (LI < 1) or (LI > 3) then
      Begin
         WriteLn('INCORRECT COMMAND LINE PARAMETER');
         Halt;
      End else PN := LI;               { PN is as given on the command line }
   End;

   K := DowCheck;

   ClrScr;
   GotoXY(20, 2);
   WriteLn('NUMBER : AN EASY EXAMPLE USING PASCAL');

   If Setup(PN) then
   Begin                                    { Initialize specified lpt port }

      If KeyOpen then
      Begin

         If GndTest then
         Begin                         { Check to see if printer is on line }

            If First then
            Begin                                 { Find the first DOW part }
               Repeat
                  GotoXY(12, 5 + PartNum);
                  Inc(PartNum);
                  RomPtr := RomData;
                  RomDta := RomPtr^;
                  If ((RomDta[1] = $81) OR (RomDta[1] = $01)) then
                     Write('DS1990/DS1420 SERIAL NUMBER       ')
                  Else
                  If ((RomDta[1] = $82) OR (RomDta[1] = $02)) then
                     Write('DS1991/DS1425 SOFTWARE KEY        ')
                  Else
                  If ((RomDta[1] = $84) OR (RomDta[1] = $04) )then
                     Write('DS1994/DS1427 TIME KEY            ')
                  Else
                     Write('Unique Dallas Semiconductor Part  ');
                  For I := 8 downto 1 Do
                      Write(Hex(RomDta[I]), ' ');
                  WriteLn;
               Until (Not Next);

               GotoXY(12, 7 + PartNum);
               WriteLn('(NUMBER OF DALLAS 1-WIRE PARTS FOUND ON LPT PORT #',PN,' IS ', PartNum, ')');

            End
            else
                WriteLn('NO DOW PARTS ON LPT PORT #', PN);
         End
         else
             WriteLn('PRINTER NOT ON LINE');
      End;

      K := KeyClose;

   End else WriteLn('SPECIFIED LPT PORT #', PN, ' DOES NOT EXIST');

End. { MAIN --------------------------------------------------------------- }


