/* ************************************************************************* */
/* Sample.c                                                                  */
/* DS Software Authorization SDK 4.3                                         */
/* Disk 1 - Dos Object & Source Files                                        */
/* 02/06/98                                                                  */
/*                                                                           */
/* Copyright (C) 1996 Dallas Semiconductor Corporation.                      */
/* All rights Reserved. Printed in U.S.A.                                    */
/* This software is protected by copyright laws of the United States and of  */
/* foreign countries.                                                        */
/* This software is furnished under a license agreement and/or a             */
/* nondisclosure agreement and may only be used or copied in accordance      */
/* with the terms of those agreements.                                       */
/* The mere transfer of this software does not imply any licenses            */
/* of trade secrets, proprietary technology, copyrights, patents,            */
/* trademarks, maskwork rights, or any other form of intellectual            */
/* property whatsoever.  Dallas Semiconductor retains all ownership rights.  */
/*                                                                           */
/* Additional Notes:                                                         */
/*                                                                           */
/*    This code was compiled using Boreland 4.5 along with the Turbo         */
/*    Assembler.  Use of other compilers may require slight modification.    */
/*                                                                           */
/*    To make project, link with <Sauth400.c>, or <Sauth400.asm>.            */
/*                                                                           */
/*    This software is intended for use with DS1410D and DS1410E and later   */
/*    model parallel port adapters only.                                     */
/*                                                                           */
/* ************************************************************************* */

#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <process.h>

typedef unsigned char uchar;

uchar far pascal setup(uchar);
uchar far pascal gndtest(void);
uchar far pascal first(void);
uchar far pascal next(void);
uchar far pascal access(void);
uchar far pascal databyte(uchar);
uchar far * far pascal romdata(void);
uchar far pascal dowcheck(void);
uchar far pascal keyopen(void);
uchar far pascal keyclose(void);

#define TRUE     1
#define FALSE    0
#define BEEP     7
#define BKSP     8
#define CR       13
#define ESC      27
#define F1       59
#define F2       60
#define F3       61
#define RARR     77
#define LARR     75
#define UPARR    72
#define DNARR    80
#define ALTH     35

#define DS1991FC 0x02          /* low 7 bits of family code of DS1991/DS1425 */

uchar pn = 0;                                /* LPT port number, default = 1 */
uchar i, j;

void center(char *s)            /* centers string horizontally on the screen */
{
    gotoxy(((80 - strlen(s)) >> 1) + 1, wherey());
    cputs(s);
}

void initmainwin(void)
{
    window(1, 4, 80, 22);
    textcolor(YELLOW); textbackground(BLUE);
    clrscr();
}

void init_scr(uchar num_found)
{
    clrscr();

   gotoxy(23, 5);            
    cprintf("NUMBER OF DS1991/DS1425's ON LPT PORT #%d = %d", pn, num_found);

    gotoxy(1, 20);
    center("PRESS ANY KEY TO CONTINUE ");
    getch();
}

void print_menu(void)
{
    window(1, 1, 80, 25);
    clrscr();

    window(1, 1, 80, 3);
    textcolor(RED); textbackground(LIGHTGRAY); clrscr();

    gotoxy(1, 1);
    center("DALLAS SEMICONDUCTOR DS1991/DS1425 DEMONSTRATION PROGRAM");

    gotoxy(1, 3);
    center("PRESS <ALT-H> FOR HELP");
    window(1, 23, 80, 25);
    clrscr();

    gotoxy(1, 1);
    center("PRESS RIGHT ARROW KEY TO ADDRESS NEXT DS1991/DS1425 ");
    gotoxy(1, 2);
    center("PRESS <ESC> TO EXIT");
    gotoxy(1, 3);
    textcolor(BLACK);
   cprintf("      F1");
   textcolor(RED);
   cprintf(" READ/WRITE SCRATCHPAD");
   textcolor(BLACK);
   cprintf("  F2");
    textcolor(RED);
    cprintf(" READ/WRITE SUBKEYS");
   textcolor(BLACK);
   cprintf("  F3");
   textcolor(RED);
   cprintf(" MOVE BLOCKS");
}

void newmenu(void)
{

   window(1, 23, 80, 25);
   textcolor(RED); textbackground(LIGHTGRAY); clrscr();
   clrscr();
   gotoxy(1, 2);
   center("PRESS <ESC> TO RETURN TO PREVIOUS SCREEN");
   initmainwin();
}

void keymenu(void)
{

    window(1, 23, 80, 25);
   textcolor(RED); textbackground(LIGHTGRAY); clrscr();
   clrscr();

   gotoxy(1, 1);
   center("PRESS <ESC> TO RETURN TO PREVIOUS SCREEN");
   gotoxy(1, 3);
   center("PRESS UPARR, DNARR KEYS TO MOVE TO DIFFERENT FIELDS");

   initmainwin();
}

void blockmenu(void)
{
   window(1, 23, 80, 25);
   textcolor(RED); textbackground(LIGHTGRAY); clrscr();
   clrscr();

   initmainwin();
}

void noALTH(void)
{
   window(1, 1, 80, 3);
   gotoxy(1, 3);
   textbackground(LIGHTGRAY); textcolor(RED);
    clreol();

   initmainwin();
}

void blockexit(void)
{
    window(1, 1, 80, 3);
   gotoxy(1, 3);
   textbackground(LIGHTGRAY); textcolor(RED);
   clreol();
   window(1, 23, 80, 25);
   textcolor(RED); textbackground(LIGHTGRAY); clrscr();
    clrscr();

   gotoxy(1, 1);
   center("PRESS <ESC> TO RETURN TO PREVIOUS SCREEN");
   while (getch() != ESC);
}

void underline(uchar y_coord, uchar len)
{
    unsigned char s[81];

   for (i = 0; i < len; i++) s[i] = 196;
   s[i] = 0;                                             /* terminate string */
   gotoxy(1, y_coord);
    center((char *) s);
}

void mainhelppage(void)
{
   window(1, 1, 80, 25);
   clrscr();
   center("MAIN SCREEN");
   underline(2, 11);
    printf("\n\n");
    center("   This screen displays the unique serial number of the DS1991/  ");
    printf("\n");
    center("DS1425s that are currently being addressed. If multiple parts    ");
    printf("\n");
    center("are present on the currently selected LPT port, a different part ");
    printf("\n");
    center("may be addressed by pressing the right arrow key until the       ");
    printf("\n");
    center("desired DS1991/DS1425's serial number is displayed on the screen.");
    printf("\n\n");
    center("   After the desired part has been selected you may exercise     ");
    printf("\n");
    center("any of it's RAM functions by pressing the function key specified ");
    printf("\n");
    center("on the last line of the display. Please note that seperate help  ");
    printf("\n");
    center("information is available for every part of this demonstration.   ");
    printf("\n\n");
    center("   On any screen of this demo, pressing the escape key will allow");
    printf("\n");
    center("you to return to the previous screen.                            ");
    printf("\n");
    gotoxy(1, 23);
    center("PRESS ANY KEY TO CONTINUE ");
    if (!getch()) getch();
    print_menu();
}

void scratchpagehelp(void)
{
   window(1, 1, 80, 25);
   clrscr();
   center("READ/WRITE SCRATCHPAD");
   underline(2, 21);
   printf("\n\n");
   center("   This screen displays the scratchpad of the currently addressed ");
   printf("\n");
   center("DS1991/DS1425.  To write new data, type in new data and press     ");
   printf("\n");
   center("<ENTER>.  The data you typed will be sent the part DS1991/DS1425  ");
   printf("\n");
   center("with the serial number displayed on the previous screen.          ");
   printf("\n");
   center("   Once the data has been written to the part, it will then be    ");
   printf("\n");
   center("read back from the part and displayed.                            ");
   printf("\n\n");
   center("   Please note that although only ascii data can be entered from  ");
   printf("\n");
   center("the keyboard, the scratchpad of the DS1991/DS1425 is non-volatile ");
   printf("\n");
   center("RAM and will accept any binary data.  For the purpose of this demo");
   printf("\n");
   center("any non-printable byte read from the part will be displayed as a  ");
   printf("\n");
   center("period.                                                           ");
   printf("\n\n");
   center("   While this demo treats the scratchpad as a single 512 bit      ");
   printf("\n");
   center("entity, this area (like the rest of the DS1991/DS1425) is byte    ");
   printf("addressable.                                                      ");
   printf("\n");
   gotoxy(1, 23);
   center("PRESS ANY KEY TO CONTINUE ");
   if (!getch()) getch();
      print_menu();
}

void keypagehelp(void)
{
    window(1, 1, 80, 25);
    clrscr();
    center("READ/WRITE SECURE SUBKEY");
    underline(2, 26);
    printf("\n\n");
    center("   This part of the demonstration allows you to READ/WRITE one of");
    printf("\n");
    center("3 secure subkeys of the selected DS1991/DS1425.  Please note     ");
    printf("\n");
    center("that the password field of any DS1991/DS1425 is WRITEONLY memory.");
    printf("\n");
    center("Since there is NO WAY to read this field from the device, the    ");
    printf("\n");
    center("demo will display a password of all spaces.  Since all-spaces is ");
    printf("\n");
    center("almost certainly an incorrect password, the data read from the   ");
    printf("\n");
    center("secure data field is probably random data (supplied by the       ");
    printf("\n");
    center("DS1991/DS1425's intelligent response generator).  If you know    ");
    printf("\n");
    center("the correct password, go to the password field, (via the up and  ");
    printf("\n");
    center("down arrow keys) type in the password and press enter.  Only then");
    printf("\n");
    center("will the actual secure data be displayed.                        ");
    printf("\n\n");
    center("   If data is entered into the secure data field when the data   ");
    printf("\n");
    center("in the password field is incorrect, the write will fail, and so  ");
    printf("\n");
    center("random data will be returned during the subsequent read.  ONLY   ");
    printf("\n");
    center("if the password is correct will the device will accept and write ");
    printf("\n");
    center("the new secure data.                                             ");
    gotoxy(1, 23);
    center("<MORE>");
    if (!getch()) getch();
    clrscr();
    center("READ/WRITE SECURE SUBKEY");
    underline(2, 26);
    printf("\n\n");
    center("   To change the password, type in a new ID field and press      ");
    printf("\n");
    center("<ENTER>.  Next, type in your new password and press <ENTER>. You ");
    printf("\n");
    center("will notice all periods in the secure data field. This is due to ");
    printf("\n");
    center("the fact that when the password is changed, the part automati-   ");
    printf("\n");
    center("cally zeros out the secure data.  Since 0 is not a printable     ");
    printf("\n");
    center("character, SAMPLE substitutes periods for the display.  Next,    ");
    printf("\n");
    center("the secure data field can be reprogrammed.                       ");
    gotoxy(1, 23);
    center("PRESS ANY KEY TO CONTINUE ");
    if (!getch()) getch();
    print_menu();
}

void blockpagehelp(void)
{
    window(1, 1, 80, 25);
    clrscr();
    center("MOVE BLOCK");
    underline(2, 11);
    printf("\n\n");
    center("  This portion of the demonstration program performs the move    ");
    printf("\n");
    center("block function of the DS1991/DS1425. This function moves a block ");
    printf("\n");
    center("of the scratchpad into the specified secure subkey. For a block  ");
    printf("\n");
    center("move to succeed, the password of the specified subkey MUST be    ");
    printf("\n");
    center("correct!  Once a move block has occurred the data in the scratch-");
    printf("\n");
    center("pad, that block (i.e., the block that was transferred) will be   ");
    printf("\n");
    center("cleared by the cleared by the DS1991/DS1425.                     ");
    printf("\n\n");
    center("   There are nine valid blocks to choose from.  Block numbers    ");
    printf("\n");
    center("0-7 are on eight byte boundaries starting at address 0 in the    ");
    printf("\n");
    center("scratchpad (ex. specifying block 2 will move bytes 16 - 23 of    ");
    printf("\n");
    center("the scratchpad into the specified secure subkey).  Block 8 trans-");
    printf("\n");
    center("fers the entire contents of the scratchpad into the specified    ");
    printf("\n");
    center("subkey.                                                          ");

    gotoxy(1, 23);
    center("<MORE>");
    if (!getch()) getch();
    clrscr();
    center("MOVE BLOCK");
    underline(2, 11);
    printf("\n\n");
    center("   Please note that if move block 1 or move block 8 is per-      ");
    printf("\n");
    center("formed the new password of the secure subkey will be equal to    ");
    printf("\n");
    center("bytes 8 - 15 of the scratchpad.  Therefore unless the original   ");
    printf("\n");
    center("password equals those scratchpad bytes, the data in the secure   ");
    printf("\n");
    center("data field will be random (since the supplied password has been  ");
    printf("\n");
    center("changed).  To verify the move block took place, just go to the   ");
    printf("\n");
    center("secure subkey portion of the demo (by pressing F2 from the main  ");
    printf("\n");
    center("screen) and supply the new password.                             ");

    gotoxy(1, 23);
    center("PRESS ANY KEY TO CONTINUE ");
    if (!getch()) getch();
    print_menu();
}

/*                                                                           */
/*    The following functions are useful in communicating with DS1991's.     */
/*    The useful stuff ends after the function transferblock().              */
/*                                                                           */

uchar DS1991s(void)
/*                                                                           */
/*        This procedure returns the number of DS1991/DS1425's present on    */
/*    LPT #pn.                                                               */
/*                                                                           */
{
    uchar part_num = 0;

    keyopen();                                        /* get control of port */

    if (first())                       /* find the first DOW part on LPT #pn */
    {
        if ((*romdata() & 0x7F) == DS1991FC) ++part_num;
      while (next()) if ((*romdata() & 0x7F) == DS1991FC) ++part_num;
   }

   keyclose();                                    /* release control of port */
   return part_num;
}

void firstDS1991(void)
/*                                                                           */
/*      This procedure returns the first DS1405/DS1425 present on            */
/*   LPT #pn.                                                                */
/*                                                                           */
{
   keyopen();                                         /* get control of port */
   if (first())                        /* find the first DOW part on LPT #pn */
   {
      if (!((*romdata() & 0x7F) == DS1991FC))
         while (next())
            if ((*romdata() & 0x7F) == DS1991FC) return;
   }
   keyclose();                                    /* release control of port */
   return;
}

uchar findnextDS1991(void)
{
   uchar sb = 0, op = 0, nr;
   keyopen();                                         /* get control of port */
   while (!sb && op < 2)
   {
      nr = next();
      if (nr && ((*romdata() & 0x7F) == DS1991FC))
         return TRUE;
        else if (!nr)
      {
         op++;
         if (first())
         {
            if ((*romdata() & 0x7F) == DS1991FC) sb = 1;
            }
         else return FALSE;
      }
   }
   keyclose();                                    /* release control of port */
   return sb;
}

uchar readscratchpad(uchar *dbuff)
/*                                                                           */
/*      This procedure reads the 64 byte scratchpad of the DS1991 currently  */
/*   selected.                                                               */
/*                                                                           */
{
   keyopen();                                         /* get control of port */
   if (access())
   {
      databyte(0x69);                /* send read scratchpad command to part */
      databyte(0xc0);   /* indicate reading scratchpad starting at address 0 */
      databyte(0x3f);            /* confirm starting address/scratchpad read */
      for (i = 0; i < 64; i++) *dbuff++ = databyte(0xff);       /* read data */

      keyclose();                                 /* release control of port */

      return TRUE;
   }
   keyclose();                                    /* release control of port */
   return FALSE;
}

uchar writescratchpad(uchar *dbuff)
/*                                                                           */
/*      This procedure writes the 64 byte scratchpad of the DS1991 currently */
/*   selected.                                                               */
/*                                                                           */
{
   keyopen();                                         /* get control of port */
   if (access())
   {
      databyte(0x96);                       /* write scratchpad command byte */
        databyte(0xc0);  /* indicate read scratchpad w/ starting address = 0 */
      databyte(0x3f);                  /* confirmation of previous byte sent */
      for (i = 0; i < 64; i++) databyte(*dbuff++);   /* send scratchpad data */

      keyclose();                                 /* release control of port */

      return TRUE;
   }
   keyclose();                                    /* release control of port */

   return FALSE;
}

uchar readsubkey(uchar *dbuff, uchar keynum)
{
   keyopen();                                         /* get control of port */
   if (access())
   {
      databyte(0x66);                          /* read secure subkey command */
      databyte((keynum << 6) + 0x10);  /*specify subkey number/starting addr */
      databyte(~((keynum << 6) + 0x10));        /* confirmation of last byte */
      for (i = 0; i < 8; i++) *dbuff++ = databyte(0xff);    /* read id field */
      for (i = 0; i < 8; i++) databyte(*dbuff++);           /* send password */
      for (i = 0; i < 48; i++) *dbuff++ = databyte(0xff);/* read secure data */

      keyclose();                                 /* release control of port */

      return TRUE;
   }
   keyclose();                                    /* release control of port */
   return FALSE;
}

uchar writesubkey(uchar *dbuff, uchar keynum)
{
   keyopen();                                         /* get control of port */
   if (access())
   {
      databyte(0x99);                         /* write secure subkey command */
      databyte((keynum << 6) + 0x10);  /*specify subkey number/starting addr */
        databyte(~((keynum << 6) + 0x10));      /* confirmation of last byte */
      for (i = 0; i < 8; i++) databyte(*dbuff++);           /* send id field */
      for (i = 0; i < 8; i++) databyte(*dbuff++);           /* send password */
      for (i = 0; i < 48; i++) databyte(*dbuff++);       /* send secure data */

      keyclose();                                 /* release control of port */

      return TRUE;
   }
   keyclose();                                    /* release control of port */
   return FALSE;
}

uchar reprogramsubkey(uchar *dbuff, uchar keynum)
{
   uchar oldid[8];                                /* buffer for old id field */

   keyopen();                                         /* get control of port */
   if (access())                         /* select proper part on 1-wire bus */
   {
      databyte(0x5A);                /* reprogram secure subkey command byte */
      databyte(keynum << 6);                        /* indicate which subkey */
      databyte(~(keynum << 6));                            /* confirm subkey */
      for (i = 0; i < 8; i++) oldid[i] = databyte(0xff);      /* read old ID */
      for (i = 0; i < 8; i++) databyte(oldid[i]);        /* send back old ID */
      for (i = 0; i < 8; i++) databyte(*dbuff++);             /* send new ID */
      for (i = 0; i < 8; i++) databyte(*dbuff++);       /* send new password */

      keyclose();                                 /* release control of port */

      return TRUE;
   }
   keyclose();                                    /* release control of port */
   return FALSE;
}

unsigned char mblks[9][8] =
{                                  /* move block 64-bit block selector codes */
  { 0x9a,0x9a,0xb3,0x9d,0x64,0x6e,0x69,0x4c},
  { 0x9a,0x9a,0x4C,0x62,0x9b,0x91,0x69,0x4c},
  { 0x9a,0x65,0xb3,0x62,0x9b,0x6e,0x96,0x4c},
  { 0x6a,0x6a,0x43,0x6d,0x6b,0x61,0x66,0x43},
  { 0x95,0x95,0xbc,0x92,0x94,0x9e,0x99,0xbC},
  { 0x65,0x9a,0x4c,0x9d,0x64,0x91,0x69,0xb3},
  { 0x65,0x65,0xb3,0x9d,0x64,0x6e,0x96,0xb3},
  { 0x65,0x65,0x4c,0x62,0x9b,0x91,0x96,0xb3},
  { 0x56,0x56,0x7f,0x51,0x57,0x5d,0x5a,0x7f}
};

uchar transferblock(uchar blocknum, uchar keynum, uchar *passwordptr)
{

   keyopen();                                         /* get control of port */
   if (access())
   {
      databyte(0x3c);                         /* send transfer block command */
      databyte(keynum << 6);                      /* indicate desired subkey */
      databyte(~(keynum << 6));             /* confirm desired subkey number */
      for (i = 0; i < 8; i++) databyte(mblks[blocknum][i]);    /* block code */
      for (i = 0; i < 8; i++) databyte(*passwordptr++);     /* send password */

      keyclose();                                 /* release control of port */

      return 1;
   }
   keyclose();                                    /* release control of port */
   return 0;
}

void printromdata(void)
{
   uchar far *addr;

   initmainwin();
    gotoxy(1, 2);
    center("UNIQUE LASERED SERIAL NUMBER OF SELECTED DS1991/1425");
    underline(3, 47);
    gotoxy(29, 4);
    addr = romdata();           /* Get pointer to eight byte ROM data buffer */
    for (i = 0; i < 8; i++) cprintf("%2.2X ", *addr++);
}

uchar scrbuffer[64];

uchar printscratchpaddata(void)
{
    uchar *dataptr;

    if (readscratchpad(scrbuffer))
    {
        newmenu();
        printromdata();
        gotoxy(1, 7);
        center("SCRATCHPAD DATA");
        underline(8, 15);
        gotoxy(8, 9); cprintf("[");
        gotoxy(9, 9);

        dataptr = scrbuffer;
        for (i = 0; i < 64; i++)
        {
            if (*dataptr < 0x20 || *dataptr > 0x7f)
                cprintf(".");                   /* not a printable character */
            else
                cprintf("%c", *dataptr);

            ++dataptr;                       /* point to next byte in buffer */
        }
        cprintf("]");
        return TRUE;
    }
    return FALSE;
}

void scratchpage(void)
{
    uchar *dataptr, kss = 0;

    initmainwin();
    if (printscratchpaddata())
    {
        gotoxy(9, 9);                /* put cursor at 1st byte of data field */
        dataptr = scrbuffer;
        while (kss != ESC)
        {
         if ((kss = getch()) == 0)
         {
            if (getch() == ALTH)
            {
               scratchpagehelp();
               initmainwin();
               printscratchpaddata();
               dataptr = scrbuffer;
               gotoxy(9, 9);
            }
            else printf("%c", BEEP);
         }
         else
         {
            switch (kss)
            {
               case BKSP:
                  if (dataptr > scrbuffer)
                  {
                     dataptr--;
                     cprintf("%c %c", BKSP, BKSP);
                  }
                  else
                     printf("%c", BEEP);
               break;

               case CR:
                  if (dataptr > scrbuffer)
                  {
                     if (writescratchpad(scrbuffer) &&         /* Write data */
                         printscratchpaddata())
                     {
                        gotoxy(9, 9); /*put cursor at 1st byte of data field */
                        dataptr = scrbuffer;
                     }
                     else
                     {
                        clrscr();
                        gotoxy(1, 5);
                    center("SELECTED DS1991/DS1425 NOT PRESENT, PRESS ANY KEY");
                        if (!getch()) getch();
                           return;
                     }
                  }
                    break;

                    case ESC:                            /* exit scratchpage */
                    break;

                    default:
                        if (dataptr == scrbuffer)        /* initialize array */
                        {
                            for (i = 0; i < 64; i++)
                            {
                                *dataptr++ = 32;
                                cputs(" ");
                            }
                            gotoxy(9, 9);
                            dataptr = scrbuffer; /* intialize buffer pointer */
                        }
                        if (dataptr < scrbuffer + 64)
                            cprintf("%c", *dataptr++ = kss);
                        else
                            printf("%c", BEEP);
                    break;
                }
            }
        }
    }
    else
    {
        gotoxy(1, 5);
        center("NO DS1991/DS1425's PRESENT");
        center("SELECTED DS1991/DS1425 NOT PRESENT, PRESS ANY KEY");
        if (!getch()) getch();
        return;
    }
}

uchar password[8][3];
uchar keybuffer[64];

uchar readanddisp(uchar keynum)
{
    if (readsubkey(keybuffer, keynum))
    {
        keymenu();
        printromdata();

        gotoxy(30, 6);
        cprintf("ID FIELD OF SUBKEY #%d", keynum);
        underline(7, 21);
        gotoxy(35, 8);
        cputs("[");
                                                           /* print id field */
        for (i = 0; i < 8; i++)
            if (keybuffer[i] > 0x1F)
                cprintf("%c", keybuffer[i]);
            else
                cprintf(".");

        cputs("]");
        gotoxy(27, 10);
        cprintf("PASSWORD FIELD OF SUBKEY #%d", keynum);
        underline(11, 27);
        gotoxy(35, 12);
        cputs("[");
                                                     /* print password field */
        for (i = 8; i < 16; i++)
            if (keybuffer[i] > 0x1F)
                cprintf("%c", keybuffer[i]);
            else
                cprintf(".");

        cputs("]");
        gotoxy(26, 14);
        cprintf("SECURE DATA FIELD OF SUBKEY #%d", keynum);
        underline(15, 30);
        gotoxy(16, 16);
        cputs("[");
                                     /* print the secure data read from part */
        for (i = 16; i < 64; i++)
            if (keybuffer[i] > 0x1F)
            cprintf("%c", keybuffer[i]);
         else
            cprintf(".");

      cputs("]");
      gotoxy(36, 8);

      return TRUE;
   }
   return FALSE;
}

void resALTH(void)
{
   window(1, 1, 80, 3);
   textbackground(LIGHTGRAY); textcolor(RED);
   gotoxy(1, 3);
   center("<ALT-H> HELP");
   initmainwin();
}

uchar keynum;

void getkeynum(void)
{
   noALTH();
    do
   {
      gotoxy(1, 5);
        center("PLEASE ENTER DESIRED SUBKEY NUMBER (0 - 2) ");
      if ((keynum = getch()) == 0)     /* did user hit function key/alt key? */
      {
         getch(); keynum = 3;                          /* set bad key number */
      }
      else keynum -= 48;                 /* Get actual key number from ascii */
   }
   while (keynum > 2);
   resALTH();
}

void printsecuredata(void)
{
   gotoxy(1, 12);
    center("SELECTED SUBKEY'S DATA");
   underline(13, 22);
   gotoxy(8, 14); cprintf("[");
   gotoxy(9, 14);

   for (i = 0; i < 64; i++)
   {
      if (keybuffer[i] < 0x20 || keybuffer[i] > 0x7f)
         cprintf(".");                          /* not a printable character */
      else
         cprintf("%c", keybuffer[i]);
   }
   cprintf("]");
}

void getblocknumber(uchar *blocknum)
{
   do
   {
      gotoxy(1, 18);
      center("PLEASE ENTER DESIRED BLOCK NUMBER (0 - 8) ");
      if ((*blocknum = getch()) == 0) /* did user hit function key/alt key ? */
      {
            if (getch() == ALTH)
         {
            blockpagehelp();
            blockmenu();
            printscratchpaddata();
            printsecuredata();
            gotoxy(1, 18);
                center("PLEASE ENTER DESIRED BLOCK NUMBER (0 - 8) ");
         }
         *blocknum = 9;                              /* set bad block number */
      }
      else if (*blocknum != ESC) *blocknum -= 48;   /* convert to actual num */
   }
    while (*blocknum > 8 && *blocknum != ESC);
}

void getpassword(void)
{
   uchar ksp = 0, *passptr;

   noALTH();
   gotoxy(15, 10);
   cprintf("PLEASE ENTER PASSWORD FOR SECURE SUBKEY #%d [        ]", keynum);
   gotoxy(59, 10);

   for (i = 8; i < 16; i++) keybuffer[i] = 0x20;
   passptr = keybuffer + 8;
   do
   {
      if ((ksp = getch()) == FALSE)
      {
         getch();
         printf("%c", BEEP);
      }
      else
      {
         if (ksp == BKSP)
         {
            if (passptr > keybuffer + 8)
            {
                    --passptr;
               cprintf("%c %c", BKSP, BKSP);
            }
            else printf("%c", BEEP);
         }
         else if (ksp != CR)
         {
            if (passptr < keybuffer + 16)
            {
               *passptr++ = ksp;
               cprintf("%c", ksp);
            }
            else printf("%c", BEEP);
            }
      }
   }
   while (ksp != CR);
   resALTH();
}

void keypage(void)
{
   uchar *dataptr, kss = 0, x, y, clrnum, plc, pkeeper, newid;
   uchar xk[3] = { 36, 36, 17 };
   uchar yk[3] = { 8, 12, 16 };
   uchar max[3] = { 8, 8, 48 };

   blockmenu();
   getkeynum();

   for (i = 0; i < 8; i++) keybuffer[i + 8] = password[i][keynum];

   if (readsubkey(keybuffer, keynum))
   {
      printromdata();                           /* display DS1991's ROM data */
      readanddisp(keynum);     /* read secure subkey and display secure data */

      newid = FALSE;
      dataptr = keybuffer;
      plc = 0; pkeeper = 0;

      while (kss != ESC)
      {
         if ((kss = getch()) == 0)
         {
            switch (kss = getch())
            {
               case UPARR:
                  if (!pkeeper)
                  {
                     if (!plc) plc = 2; else --plc;
                     dataptr = keybuffer + 8 * plc;
                     gotoxy(xk[plc], yk[plc]);
                        }
               break;

               case DNARR:
                  if (!pkeeper)
                  {
                     if (plc < 2) ++plc; else plc = 0;
                     dataptr = keybuffer + 8 * plc;
                     gotoxy(xk[plc], yk[plc]);
                  }
               break;

               case ALTH:
                  keypagehelp();
                  printromdata();
                  readanddisp(keynum);
                  newid = FALSE;
                  dataptr = keybuffer;
                  plc = 0; pkeeper = 0;
               break;

               default:
                  printf("%c", BEEP);
               break;
            }
         }
         else
            {
            switch (kss)
            {
               case BKSP:
                  if (pkeeper)
                  {
                     --pkeeper;
                     --dataptr;
                     cprintf("%c %c", BKSP, BKSP);
                  }
                  else printf("%c", BEEP);
               break;

                    case CR:
                  switch (plc)
                  {
                     case 0:
                        gotoxy(xk[1], yk[1]);
                        for (i = 8; i < 16; i++)
                        {
                           cprintf(" "); keybuffer[i] = 0x20;
                        }

                        gotoxy(xk[2], yk[2]);
                        for (i = 16; i < 64; i++)
                        {
                           cprintf(" "); keybuffer[i] = 0x20;
                        }
                        plc = 1;
                        gotoxy(xk[plc], yk[plc]);
                        pkeeper = 0;
                        dataptr = keybuffer + 8;
                        newid = TRUE;
                     break;

                     case 1:
                        if (newid) reprogramsubkey(keybuffer, keynum);
                        if (!readanddisp(keynum))
                        {
                            clrscr(); gotoxy(1, 5);
                     center("SELECTED DS1991/DS1425 NOT PRESENT,PRESS ANY KEY");
                            if (!getch()) getch();
                                return;
                        }
                            pkeeper = 0;
                            plc = newid ? 2 : 0;
                            gotoxy(xk[plc], yk[plc]);
                            dataptr = newid ? keybuffer + 16 : keybuffer;
                            newid = FALSE;
                        break;

                    case 2:
                        if (!(writesubkey(keybuffer, keynum) &&
                            readanddisp(keynum)))
                        {
                           clrscr(); gotoxy(1, 5);
                     center("SELECTED DS1991/DS1425 NOT PRESENT,PRESS ANY KEY");
                           if (!getch()) getch();
                           return;
                        }
                        plc = 0; pkeeper = 0;
                        gotoxy(xk[plc], yk[plc]);
                        dataptr = keybuffer;
                     break;
                  }
               break;

               default:
                  if (!pkeeper)
                  {
                     x = wherex(); y = wherey();
                     clrnum = (plc == 2) ? 48 : 8;
                     for (i = 0; i < clrnum; i++)
                     {
                        cprintf(" ");
                        *dataptr++ = 0x20;
                     }
                     dataptr -= clrnum;    /* move data pointer to beginning */
                     gotoxy(x, y);
                  }
                        if (pkeeper < max[plc])
                        {
                     cprintf("%c", kss);
                     *dataptr++ = kss;
                     ++pkeeper;
                  }
                  else printf("%c", BEEP);
               break;
            }
         }
      }
   }
   else
   {
      clrscr();
      gotoxy(1, 5);
      center("SELECTED DS1991/DS1425 NOT PRESENT, PRESS ANY KEY");
      if (!getch()) getch();
      return;
   }
}

void moveblockpage(void)
{
   uchar blocknum, *passwptr;

   blockmenu();
   getkeynum();
   getpassword();

   if (printscratchpaddata() && readsubkey(keybuffer, keynum))
   {
      printsecuredata();

      getblocknumber(&blocknum);
      if (blocknum == ESC) return;                     /* move block aborted */
      passwptr = keybuffer + 8;
      transferblock(blocknum, keynum, passwptr);

      initmainwin();
        printscratchpaddata();
        readsubkey(keybuffer, keynum);
        printsecuredata();

        blockexit();
    }
    else
    {
        gotoxy(1, 5);
        center("NO DS1991/DS1425's PRESENT");
        center("SELECTED DS1991/DS1425 NOT PRESENT, PRESS ANY KEY");
        if (!getch()) getch();
      return;
   }
}

uchar num_found, ks, pfound;

void main(void)
{
   pfound = FALSE;

   dowcheck();

   while (!pfound && pn++ < 4)                 /* Search ports for DOW parts */
   {
      if (setup(pn))                          /* Check for existance of port */
      {
         if (keyopen())
         {
            if (gndtest())           /* If printer is attached is it on line */
               if (first())            /* See if a DS1991 is on LPT port #pn */
                  pfound = TRUE;        /* Atleast 1 part is on LPT port #pn */
         }
         keyclose();
      }
   }

   if (pn > 3)                    /* If pn > 3 no parts were on any LPT port */
    {
        printf("No DS1991/DS1425 found on any LPT port\n");
        exit(0);
    }

    if ((num_found = DS1991s()) > 0)     /* Find all DS1991s on LPT port #pn */
    {
        init_scr(num_found);
        print_menu();

        firstDS1991();                  /* Select first part on LPT port #pn */
        printromdata();                     /* Print selected parts ROM data */

      for (i = 0; i < 8; i++) for (j = 0; j < 3; j++) password[i][j] = 0x20;
      while (TRUE)
      {
         if (kbhit())
         {
            if ((ks = getch()) == FALSE)
            {
               switch (ks = getch())
               {
                  case F1:
                     scratchpage();
                     initmainwin();          /* Clear main window of display */
                     print_menu();                        /* Print main menu */
                     printromdata();      /* Print ROM data of selected part */
                  break;

                  case F2:
                     keypage();
                     initmainwin();          /* Clear main window of display */
                     print_menu();                        /* Print main menu */
                     printromdata();      /* Print ROM data of selected part */
                  break;

                  case F3:
                     moveblockpage();
                     initmainwin();          /* Clear main window of display */
                     print_menu();                        /* Print main menu */
                     printromdata();      /* Print ROM data of selected part */
                        break;

                        case RARR:   /* get next part on bus, or back to 1st */
                        if (findnextDS1991())
                            printromdata();
                        else
                        {
                            window(1, 1, 80, 25); clrscr();
                          printf("No DS1991/DS1425's currently on LPT #%d", pn);
                            exit(0);
                        }
                  break;

                  case ALTH:
                     mainhelppage();                    /* Print help screen */
                     initmainwin();          /* Clear main window of display */
                     print_menu();                        /* Print main menu */
                     printromdata();      /* Print ROM data of selected part */
                  break;

                  default:
                     printf("%c", BEEP);
                  break;
               }
            }
            else if (ks == ESC)
            {
               window(1, 1, 80, 25);
               clrscr();
               exit(0);
            }
            else printf("%c", BEEP);
         }
      }
   }
    else printf("\nNo DS1991/DS1425's on LPT port #%d\n", pn);
    exit(0);
}


