/*
   Makekey.c                                           { Ver 1.01  11/08/94 }
                                                       { Ver 1.02  06/20/96 }
    Copyright (C) 1996 Dallas Semiconductor Corporation. 
    All rights Reserved. Printed in U.S.A.
    This software is protected by copyright laws of
    the United States and of foreign countries.
    This material may also be protected by patent laws of the United States 
    and of foreign countries.
    This software is furnished under a license agreement and/or a
    nondisclosure agreement and may only be used or copied in accordance
    with the terms of those agreements.
    The mere transfer of this software does not imply any licenses
    of trade secrets, proprietary technology, copyrights, patents,
    trademarks, maskwork rights, or any other form of intellectual
    property whatsoever. Dallas Semiconductor retains all ownership rights.
*/

#include <stdio.h>

unsigned char far pascal setup(unsigned char pn);
unsigned char far pascal first(void);
unsigned char far pascal next(void);
unsigned char far pascal access(void);
unsigned char far pascal gndtest(void);
unsigned char far pascal databyte(unsigned char x);
unsigned char far * far pascal romdata(void);
unsigned char far pascal dowcheck(void);
unsigned char far pascal keyopen(void);
unsigned char far pascal keyclose(void);

unsigned char LptNo = 1, found = 0, i, rnd[48], tr[8];
unsigned char id[8]   = { 68, 65, 76, 32, 83, 69, 77, 73 };/* (DAL SEMI) */
unsigned char pass[8] = { 80, 65, 83, 83, 84, 69, 83, 84 };/* (PASSTEST) */
						/* (THIS IS SECURE DATA) */
unsigned char sd[48] = { 84, 72, 73, 83, 32, 73, 83, 32, 83,
			 69, 67, 85, 82, 69, 32, 68, 65, 84,
			 65 };

int DS14X5(void)
{
   unsigned char far *romptr;

   romptr = (unsigned char far *) romdata();
   return ((*romptr & 0x7F) == 0x02);
}

void main(void)
{
   dowcheck();
   while(!found && setup(LptNo++)) 
   {
      if (keyopen())              /* get control of port */
      {
         if (gndtest()) 
         {
	         if (first() && DS14X5()) {
	            for (i = 19; i < 48; i++) sd[i] = 32;/* fill rest with spaces */
	            access();          /* prepare part for read with bad password */
	            databyte(0x66);                   /* read secure data command */
	            databyte(0x10);                          /* byte 16, subkey 0 */
	            databyte(0xef);                    /* confirm address, subkey */
	            for (i = 0; i < 8; i++) databyte(0xff);            /* read id */
	            for (i = 0; i < 8; i++) databyte(pass[i]);/* send bad passwrd */
	            for (i = 0; i < 48; i++) rnd[i] = databyte(0xff);
	            access();              /* reset part for set password command */
	            databyte(0x5a);                           /* set new password */
	            databyte(0x0);                                       /* key 0 */
	            databyte(0xff);                              /* confirm key # */
	            for (i = 0; i < 8; i++) tr[i] = databyte(0xff);/* read old id */
	            for (i = 0; i < 8; i++) databyte(tr[i]); /* send back same id */
	            for (i = 0; i < 8; i++) databyte(id[i]);   /* send (DAL SEMI) */
	            for (i = 0; i < 8; i++) databyte(rnd[i]);/* send new password */
	            access();           /* reset part for set secure data command */
	            databyte(0x99);                            /* set secure data */
	            databyte(0x10);                             /* key 0, byte 16 */
	            databyte(0xef);                   /* confirm key, byte number */
	            for (i = 0; i < 8; i++) databyte(0xff);
	            for (i = 0; i < 8; i++) databyte(rnd[i]);    /* send password */
	            for (i = 0; i < 48; i++) databyte(sd[i] ^ rnd[i]);/*send data */
	            found = 1;                                /* set success flag */
	         }
         } else printf("\nPrinter not on line");
      }
      keyclose();             /* release control of port */
   }
   if (found) 
      printf("\nKey has been made"); 
   else 
      printf("No DS14X5 found or DS14X5 was not first part on bus\n");
}



