{
   Sample.pas                                           Ver 1.01 11/08/94 
                                                        Ver 1.02 06/20/96

   Copyright (C) 1996 Dallas Semiconductor Corporation. 
   All rights Reserved. Printed in U.S.A.
   This software is protected by copyright laws of
   the United States and of foreign countries.
   This material may also be protected by patent laws of the United States 
   and of foreign countries.
   This software is furnished under a license agreement and/or a
   nondisclosure agreement and may only be used or copied in accordance
   with the terms of those agreements.
   The mere transfer of this software does not imply any licenses
   of trade secrets, proprietary technology, copyrights, patents,
   trademarks, maskwork rights, or any other form of intellectual
   property whatsoever. Dallas Semiconductor retains all ownership rights.
}

Program Sample;

Uses DOS, CRT, SauthP;

Const
   ESC = 27;
   BKSP = 8;
   CR = 13;
   F1 = 59;
   F2 = 60;
   F3 = 61;
   RARR = 77;
   LARR = 75;
   UPARR = 72;
   DNARR = 80;
   ALTH = 35;

Var
   PN, I, J, JB : Byte;
   DBuff        : Array[0..63] of Byte;
   PasswordData : Array[0..7] of Byte;

Procedure Center(X: String);

Begin
  GotoXY(Succ((80-Length(X)) shr 1), WhereY);
  WriteLn(X);
End;

Function Hex(X: Byte): String;
{
  This function returns the hexadecimal representation string
  of the byte passed to it.
}

Var
  S : String[2];
  I, J : Byte;

Begin
  S := '';
  For I := 1 to 2 do Begin
     J := X and $F;
     X := X shr 4;
     If J > 9 then Inc(J, 7);
     S := Char(J + $30) + S
  End;
  Hex := S;
End;

Procedure InitMainWin;

Begin
   Window(1, 4, 80, 22);
   TextColor(Yellow); TextBackGround(Blue);
   ClrScr;
End;

Procedure Init_Scr(Num_Found: Byte);

Var
   tr : Char;

Begin
   ClrScr;
   GotoXY(23, 5);
   WriteLn('NUMBER OF DS14X5''s ON LPT PORT #', PN, ' = ', Num_Found);
   GotoXY(27, 20);
   Write('PRESS ANY KEY TO CONTINUE ');
   tr := ReadKey;
End;

Procedure Print_Menu;

Begin
   Window(1, 1, 80, 25); 
   ClrScr;
   Window(1, 1, 80, 3);
   TextColor(RED); TextBackGround(LIGHTGRAY); ClrScr;
   GotoXY(17, 1);
   Write('DALLAS SEMICONDUCTOR DS14x5 DEMONSTRATION PROGRAM');
   GotoXY(30, 3);
   Write('PRESS <ALT-H> FOR HELP');
   Window(1, 23, 80, 25); 
   ClrScr;
   GotoXY(1, 1);
   Center('PRESS RIGHT ARROW KEY TO ADDRESS NEXT DS14x5 ');
   GotoXY(1, 2);
   Center('PRESS <ESC> TO EXIT');
   GotoXY(1, 3);
   TextColor(BLACK);
   Write('      F1');
   TextColor(RED);
   Write(' READ/WRITE SCRATCHPAD');
   TextColor(BLACK);
   Write('  F2');
   TextColor(RED);
   Write(' READ/WRITE SUBKEYS');
   TextColor(BLACK);
   Write('  F3');
   TextColor(RED);
   Write(' MOVE BLOCKS');
End;

Procedure NewMenu;

Begin
   Window(1, 23, 80, 25); 
   TextColor(RED); TextBackGround(LIGHTGRAY); ClrScr;
   ClrScr;
   GotoXY(23, 2);
   Center('PRESS <ESC> TO RETURN TO PREVIOUS SCREEN');
{
   GotoXY(1, 3);
   Center('TO WRITE TO SELECTED DS14x5 TYPE IN NEW DATA AND PRESS <ENTER>');
}
   InitMainWin;
End;

Procedure KeyMenu;

Begin
   Window(1, 23, 80, 25);
   TextColor(RED); TextBackGround(LIGHTGRAY); ClrScr;
   ClrScr;
   GotoXY(23, 1);
   Write('PRESS <ESC> TO RETURN TO PREVIOUS SCREEN');
   GotoXY(17, 3);
   Write('PRESS UPARR, DNARR KEYS TO MOVE TO DIFFERENT FIELDS');
{
   GotoXY(10, 3);
   Write('TO WRITE TO SELECTED DS14x5 TYPE IN NEW DATA AND PRESS <ENTER>');
}
   InitMainWin;
End;

Procedure BlockMenu;

Begin
   Window(1, 23, 80, 25); 
   TextColor(RED); TextBackGround(LIGHTGRAY); ClrScr;
   ClrScr;
   InitMainWin;
End;

Procedure NoALTH;

Begin
   Window(1, 1, 80, 3);
   GotoXY(1, 3);
   TextBackGround(LIGHTGRAY); TextColor(RED);
   ClrEol;
   InitMainWin;
End;

Procedure BlockExit;

Begin
   Window(1, 1, 80, 3);
   GotoXY(1, 3);
   TextBackGround(LIGHTGRAY); TextColor(RED);
   ClrEol;
   Window(1, 23, 80, 25); 
   TextColor(RED); TextBackGround(LIGHTGRAY); ClrScr;
   ClrScr;
   GotoXY(20, 1);
   Write('PRESS <ESC> TO RETURN TO PREVIOUS SCREEN');
   Repeat Until KeyPressed And (ReadKey = #27);
End;

Procedure UnderLine(Y_Coord, Len: Byte);

Var
   S : String;

Begin
   S := '';
   For I := 1 to Len Do S := S + Char(196);
   GotoXY(1, Y_Coord);
   Center(s);
End;

Procedure MainHelpPage;

Begin
   Window(1, 1, 80, 25);
   ClrScr;
   Center('MAIN SCREEN');
   UnderLine(2, 11);
   Center('   This screen displays the unique serial number of the DS1405/');
   Center('DS1425 that is currently being addressed. If multiple DS14x5s  ');
   Center('are present on the currently selected LPT port, another DS14x5 ');
   Center('may be addressed by pressing the right arrow key until the     ');
   Center('desired DS14x5''s serial number is displayed on the screen.     ');
   Center('   After the desired DS14x5 has been selected you may exercise ');
   Center('any of its RAM functions by pressing the function key specified');
   Center('on the last line of the display. Please note that seperate help');
   Center('information is available for every part of this demonstration. ');
   Center('   On any screen of this demo, pressing the escape key will    ');
   Center('allow you to return to the previous screen.                    ');
   GotoXY(27, 23); 
   Write('PRESS ANY KEY TO CONTINUE ');
   JB := Byte(ReadKey);
   If JB = 0 then JB := Byte(ReadKey);
   Print_Menu;
End;

Procedure ScratchPageHelp;

Begin
   Window(1, 1, 80, 25); 
   ClrScr;
   Center('READ/WRITE SCRATCHPAD');
   UnderLine(2, 21);
   Center('   This screen displays the scratchpad of the currently addressed');
   Center('DS14x5. To write new data into the scratchpad type in new data   ');
   Center('and press <ENTER>. The data you typed will be sent the the DS14x5');
   Center('(the DS14x5 with the serial number displayed on the previous     ');
   Center('screen). Once the data has been written to the DS14x5, it will be');
   Center('read back from the part and displayed.                           ');
   Center('   Please note that even though only ascii data can be entered   ');
   Center('from the keyboard, the scratchpad of the DS14x5 is non-volatile  ');
   Center('RAM and will accept any binary data. For the purposes of display ');
   Center('any non-printable byte read from the part will be displayed as a '); 
   Center('period.                                                          ');
   Center('   While this demo treats the scratchpad as a single 512 bit     ');
   Center('entity,this area like the rest of the DS14X5 is byte addressable.');
   GotoXY(27, 23); 
   Write('PRESS ANY KEY TO CONTINUE ');
   JB := Byte(ReadKey);
   If JB = 0 then JB := Byte(ReadKey);
   Print_Menu;
End;

Procedure KeyPageHelp;

Begin
   Window(1, 1, 80, 25); 
   ClrScr;
   Center('READ/WRITE SECURE SUBKEY');
   UnderLine(2, 26);
   Center('   This part of the demonstration allows you to READ/WRITE one of');
   Center('3 secure subkeys of the currently addressed DS14x5. Please note  ');
   Center('that the password field of any DS14x5 is WRITE only memory. There');
   Center('is NO way to read this field from the device. For this reason    ');
   Center('SAMPLE will assume a password of all spaces. This is almost cer- ');
   Center('tainly an incorrect password, and therefore the data read from   ');
   Center('the secure data field is random data (the false password seeds   ');
   Center('the DS14X5''s intelligent response generator). If you know the    ');
   Center('correct password, go to the password field (via the up and down  '); 
   Center('arrow keys) and type in the password and press enter. You will   '); 
   Center('then see your secure data displayed.                             ');
   Center('   If data is entered into the secure data field when the data   ');
   Center('in the password field is incorrect the write will fail, and the  ');
   Center('random data will be returned. If the password is correct the     ');
   Center('device will accept the new secure data.                          '); 
   GotoXY(37, 23); 
   Write('<MORE>');
   JB := Byte(ReadKey);
   If JB = 0 then JB := Byte(ReadKey);
   ClrScr;
   Center('READ/WRITE SECURE SUBKEY');
   UnderLine(2, 26);
   Center('   To change the password, type in a new ID field and press      '); 
   Center('<ENTER>. Next type in your new password and press <ENTER>. You   '); 
   Center('will notice all periods in the secure data field. This is due to ');
   Center('the fact that after the password is changed the part clears the  '); 
   Center('secure data field(fills it with binary 0''s). Since 0 is not a    ');
   Center('printable byte, SAMPLE substitutes periods for the display. Next ');
   Center('the secure data field can be reprogrammed.                       ');
   GotoXY(27, 23); 
   Write('PRESS ANY KEY TO CONTINUE ');
   JB := Byte(ReadKey);
   If JB = 0 then JB := Byte(ReadKey);
   Print_Menu;
End;

Procedure BlockPageHelp;

Begin
   Window(1, 1, 80, 25);
   ClrScr;
   Center('MOVE BLOCK');
   UnderLine(2, 11);
   Center('   This portion of the demonstration program performs the move');
   Center('block function of the DS14x5. This function moves a block of  ');
   Center('the scratchpad into the specified secure subkey. For a block  ');
   Center('move to occur, the password of the specified subkey MUST be   ');
   Center('correct. Once a move block has occurred the data in the       ');
   Center('scratchpad (only the block that was transferred) will be      ');
   Center('cleared by the DS14x5.                                        ');
   Center('   There are nine valid blocks to choose from. Block numbers  ');
   Center('0-7 are on eight byte boundaries starting at address 0 in the ');
   Center('scratchpad (ex. specifying block 2 will move bytes 16 - 23 of ');
   Center('the scratchpad into the specified secure subkey). Block 8     ');
   Center('transfers the entire contents of the scratchpad into the      ');
   Center('specified subkey.                                             ');
   GotoXY(37, 23);
   Write('<MORE>');
   JB := Byte(ReadKey);
   If JB = 0 then JB := Byte(ReadKey);
   ClrScr;
   Center('MOVE BLOCK');
   UnderLine(2, 11);
   Center('   Please note that if move block 1 or move block 8 is per-   ');
   Center('formed the new password of the secure subkey will be equal to ');
   Center('bytes 8 - 15 of the scratchpad. Therefore unless the original ');
   Center('password equals those scratchpad bytes, the data in the secure');
   Center('data field will be random (since the supplied password has    ');
   Center('been changed). To verify the move block took place go to the  ');
   Center('secure subkey portion of the demo (by pressing F2 from the    ');
   Center('main screen) and supply the new password.                     ');
   GotoXY(27, 23);
   Write('PRESS ANY KEY TO CONTINUE ');
   JB := Byte(ReadKey);
   If JB = 0 then JB := Byte(ReadKey);
   Print_Menu;
End;

{
   ******************************************************************
   The following functions are useful in communicating with DS14x5's. 
   The useful stuff ends after the function TransferBlock.
   ******************************************************************
}

Type
   RomAry = Array[1..8] of Byte;
   PasSet = Array[0..2] of RomAry;

Var
   RomPtr  : ^RomAry;
   RomDta  : RomAry;
   PasData : PasSet;

Function DS14x5s: Byte;
{
      This function returns the number of DS1405's/DS1425's present on
   LPT #pn.  
}
Var
   Part_Num : Byte;
   K        : Boolean;
Begin
   Part_Num := 0;
   K := KeyOpen;                  { Get control of port }
   If First then Begin
   RomPtr := RomData;        { Get pointer to the 8 byte ROM data buffer }
   RomDta := RomPtr^;
   If RomDta[1] = $82 then Inc(Part_Num);            { Is this a DS14x5? }
      While Next do Begin
         RomDta := RomPtr^;
         If RomDta[1] = $82 then Inc(Part_Num);
         RomPtr := RomData;
      End;
   End;
   K := KeyClose;                 { Release control of port }
   DS14x5s := Part_Num;
End;

Procedure FirstDS14x5;
{
   This procedure returns the first DS1405/DS1425 present on LPT #pn.
}
Var
   K : Boolean;
Begin
   K := KeyOpen;
   If First then Begin                  { find the 1st DOW part on LPT #pn }
      RomPtr := RomData;       { Get pointer to the 8 byte ROM data buffer }
      RomDta := RomPtr^;
      If RomDta[1] <> $82 then While Next do Begin
         RomDta := RomPtr^;
         If RomDta[1] = $82 then Exit;
      End;
   End;
   K := KeyClose;
End;

Function FindNextDS14x5: Boolean;
{
      This Function finds the next ds1405/DS1425 present on LPT #pn. If no
   more are present it returns FALSE.
}
Var
   SB, NR, K : Boolean;
   OP        : Byte;

Begin
   SB := False; OP := 0;
   K := KeyOpen;
   While ((Not SB) And (OP < 2)) do Begin
      NR := Next;
      RomPtr := RomData;     { Get pointer to the 8 byte ROM data buffer }
      RomDta := RomPtr^;
      If (NR And (RomDta[1] = $82)) then
         SB := True
      else if (Not NR) then Begin
         Inc(OP);
         If First then Begin
            RomDta := RomPtr^;
            If RomDta[1] = $82 then SB := TRUE;
         End;
      End;
   End;
   K := KeyClose;
   FindNextDS14x5 := SB;
End;

Function ReadScratchPad: Boolean;
{
      This procedure reads the 64 byte scratchpad of the DS14x5 currently
   selected.
}
Var
   DB : Byte;
   K  : Boolean;
Begin
   K := KeyOpen;
   If Access then Begin
      DB := Databyte($69);           { send read scratchpad command to part }
      DB := Databyte($C0);      { indicate scratchpad starting at address 0 }
      DB := Databyte($3F);       { confirm starting address/scratchpad read }
      For I := 0 to 63 do DBuff[I] := Databyte($FF);            { Read Data }
      ReadScratchPad := TRUE;
   End Else ReadScratchPad := FALSE;
   K := KeyClose;
End;

Function WriteScratchPad: Boolean;
{
      This procedure writes the 64 byte scratchpad of the DS14x5 currently
   selected.
}
Var
   DB : Byte;
   K  : Boolean;
Begin
   K := KeyOpen;
   If Access then Begin
      DB := Databyte($96);                   { write scratchpad command byte }
      DB := Databyte($C0);     { indicate scratchpad w/ starting address = 0 }
      DB := Databyte($3F);              { confirmation of previous byte sent }
      For I := 0 to 63 do DB := Databyte(DBuff[I]);             { Write Data }
      WriteScratchPad := TRUE;
   End Else WriteScratchPad := FALSE;
   K := KeyClose;
End;

Function ReadSubkey(Keynum: Byte): Boolean;

Var
   DB : Byte;
   K  : Boolean;
Begin
   K := KeyOpen;
   If Access then Begin
      DB := Databyte($66);                     { read secure subkey command }
      DB := Databyte((Keynum Shl 6) + $10);         { specify subkey number }
      DB := Databyte(((Keynum Shl 6) + $10) Xor $FF);        { confirmation }
      For I := 0 to 7 do DBuff[I] := Databyte($FF);         { read id field }
      For I := 8 to 15 do DB := Databyte(DBuff[I]);         { send password }
      For I := 16 to 63 do DBuff[I] := Databyte($FF);    { read secure data }
      ReadSubKey := TRUE;
   End Else ReadSubKey := FALSE;
   K := KeyClose;
End;

Function WriteSubkey(Keynum: Byte): Boolean;

Var
   DB : Byte;
   K  : Boolean;
Begin
   K := KeyOpen;
   If Access then Begin
      DB := Databyte($99);                    { write secure subkey command }
      DB := Databyte((Keynum Shl 6) + $10);         { specify subkey number }
      DB := Databyte(((Keynum Shl 6) + $10) Xor $FF);        { confirmation }
      For I := 0 to 7 do DBuff[I] := Databyte($FF);         { read id field }
      For I := 8 to 15 do DB := Databyte(DBuff[I]);         { send password }
      For I := 16 to 63 do DB := Databyte(DBuff[I]);     { send secure data }
      WriteSubKey := TRUE;
   End Else WriteSubKey := FALSE;
   K := KeyClose;
End;

Function ReprogramSubKey(Keynum: Byte): Boolean;

Var
   DB    : Byte;
   OldID : Array[0..7] of Byte;              { temp buffer for old id field }
   K     : Boolean;
Begin
   K := KeyOpen;
   If Access then Begin                  { select proper part on 1-wire bus }
      DB := Databyte($5A);           { reprogram secure subkey command byte }
      DB := Databyte(Keynum Shl 6);                 { indicate which subkey }
      DB := Databyte((Keynum Shl 6) Xor $FF);              { confirm subkey }
      For I := 0 to 7 do OldID[I] := Databyte($FF);           { read old ID }
      For I := 0 to 7 do DB := Databyte(OldID[I]);       { send back old ID }
      For I := 0 to 7 do DB := Databyte(DBuff[I]);            { send new ID }
      For I := 8 to 15 do DB := Databyte(DBuff[I]);     { send new password }
      ReprogramSubKey := TRUE;
   End Else ReprogramSubKey := FALSE;
   K := KeyClose;
End;

Const                              { move block 64-bit block selector codes }
   mblks : Array[0..8, 0..7] of Byte = (
   ($9a, $9a, $b3, $9d, $64, $6e, $69, $4c),
   ($9a, $9a, $4C, $62, $9b, $91, $69, $4c),
   ($9a, $65, $b3, $62, $9b, $6e, $96, $4c),
   ($6a, $6a, $43, $6d, $6b, $61, $66, $43),
   ($95, $95, $bc, $92, $94, $9e, $99, $bC),
   ($65, $9a, $4c, $9d, $64, $91, $69, $b3),
   ($65, $65, $b3, $9d, $64, $6e, $96, $b3),
   ($65, $65, $4c, $62, $9b, $91, $96, $b3),
   ($56, $56, $7f, $51, $57, $5d, $5a, $7f));

Function TransferBlock(Keynum, BlockNum: Byte): Boolean;

Var
   DB : Byte;
   K  : Boolean;
Begin
   K := KeyOpen;
   If Access Then Begin
      DB := Databyte($3C);                    { send transfer block command }
      DB := Databyte(Keynum Shl 6);               { indicate desired subkey }
      DB := Databyte((Keynum Shl 6) Xor $FF);{confirm desired subkey number }
      For I := 0 to 7 do DB := Databyte(mblks[BlockNum][I]);{send block code}
      For I := 8 to 15 do DB := Databyte(DBuff[I]);       { send block code }
      TransferBlock := True;
   End Else TransferBlock := False;
   K := KeyClose;
End;

Procedure PrintRomData;

Begin
   InitMainWin;
   GotoXY(1, 2);
   Center('UNIQUE LASERED SERIAL NUMBER OF SELECTED DS14X5');
   UnderLine(3, 47);
   GotoXY(29, 4);
   RomPtr := RomData;          { Get pointer to the 8 byte ROM data buffer }
   RomDta := RomPtr^;
   For I := 1 to 8 do Write(Hex(RomDta[I]), ' ');
End;

Function PrintScratchPadData: Boolean;

Begin
   If ReadScratchPad then Begin
      NewMenu;
      PrintRomData;
      GotoXY(1, 7);
      Center('SCRATCHPAD DATA');
      UnderLine(8, 15);
      GotoXY(8, 9); Write('['); 
      For I := 0 to 63 do 
         If DBuff[I] > $1F then Write(Char(DBuff[I])) Else Write('.');
      Write(']');
      PrintScratchPadData := True;
   End Else PrintScratchPadData := False;
End;

Procedure ScratchPage;

Var
   KSS, PLC : Byte;

Begin
   InitMainWin;
   If PrintScratchPadData then Begin
      GotoXY(9, 9);
      PLC := 0;                                       { Index into DBuff array }
      KSS := 0;   
      While KSS <> ESC do Begin
         KSS := Byte(ReadKey);
         If KSS = 0 then Begin
            If Byte(ReadKey) = ALTH then Begin
               ScratchPageHelp;
               InitMainWin;
               If PrintScratchPadData then;
               PLC := 0;
               GotoXY(9, 9);
            End Else Write(Char(7));
         End Else Begin
            If KSS = BKSP then Begin 
               If (PLC > 0) then Begin
                  Dec(PLC);
                  Write(Char(BKSP), ' ', Char(BKSP));
               End Else Write(Char(7));
            End Else If KSS = CR then Begin
               If (PLC > 0) then Begin
                  If (WriteScratchPad And PrintScratchPadData) then Begin
                     GotoXY(9, 9); { Put cursor at first byte of data field }
                     PLC := 0;               { Reset index into data buffer }
                  End else Begin 
                     GotoXY(1, 5);
                     Center('NO DS14X5s PRESENT');
                     GotoXY(28, 6);
                     Write('PRESS ANY KEY TO CONTINUE');
                     KSS := Byte(ReadKey);
                     If KSS = 0 then KSS := Byte(ReadKey); 
                  End;
               End;
            End Else If KSS <> ESC then Begin
               If PLC = 0 then Begin
                  For I := 0 to 63 do Begin
                     DBuff[I] := $20;
                     Write(' ');
                  End;
                  GotoXY(9, 9);
               End; 
               If PLC < 64 then Begin
                  Write(Char(KSS));
                  DBuff[PLC] := KSS;
                  Inc(PLC);
               End Else Write(Char(7));
            End;
         End;
      End;
   End Else Begin
      GotoXY(1, 5);
      Center('NO DS14X5s PRESENT');
      GotoXY(28, 6);
      Write('PRESS ANY KEY TO CONTINUE');
      KSS := Byte(ReadKey);
      If KSS = 0 then KSS := Byte(ReadKey); 
   End;
End; 

Function ReadAndDisp(KeyNum: Byte): Boolean;

Begin
   If (ReadSubKey(KeyNum)) then Begin
      KeyMenu;
      PrintRomData;
      GotoXY(30, 6);
      Write('ID FIELD OF SUBKEY #', KeyNum);
      UnderLine(7, 21);
      GotoXY(35, 8); Write('[');
      For I := 0 to 7 do                                { Print ID field data }
         If DBuff[I] > $1F then Write(Char(DBuff[I])) else Write('.');
      Write(']');
      GotoXY(27, 10);
      Write('PASSWORD FIELD OF SUBKEY #', KeyNum);
      UnderLine(11, 27);
      GotoXY(35, 12); Write('[');
      For I := 8 to 15 do                               { Print ID field data }
         If DBuff[I] > $1F then Write(Char(DBuff[I])) else Write('.');
      Write(']');
      GotoXY(26, 14);
      Write('SECURE DATA FIELD OF SUBKEY #', KeyNum);
      UnderLine(15, 30);
      GotoXY(16, 16); Write('[');
      For I := 16 to 63 do                             { Print ID field data }
         If DBuff[I] > $1F then Write(Char(DBuff[I])) else Write('.');
      Write(']');
      GotoXY(36, 8);
      ReadAndDisp := True;
   End Else ReadAndDisp := False;
End;

Procedure ResALTH;

Begin
   Window(1, 1, 80, 3);
   TextBackGround(LightGray); TextColor(Red);
   GotoXY(30, 3);
   Write('PRESS <ALT-H> FOR HELP');
   InitMainWin;
End;

Var
   KeyNum, BlockNum : Byte;

Procedure GetKeyNum;

Begin
   NoALTH;
   Repeat
      GotoXY(20, 5); 
      Write('PLEASE ENTER DESIRED SUBKEY NUMBER (0 - 2) ');
      KeyNum := Byte(ReadKey);
      If KeyNum = 0 then Begin        { Did user hit an ALT or FUNCTION key } 
         JB := Byte(ReadKey);                     { If so soak up keystroke }
         KeyNum := 3;                    { Set invalid secure subkey number }
      End Else KeyNum := KeyNum - 48;         { Get keynum from ascii value }
   Until ((KeyNum >= 0) And (KeyNum < 3));
   ResAlTH;
End;

Procedure PrintSecureData;

Begin 
   GotoXY(1, 12);
   Center('SELECTED SUBKEY''S DATA');
   UnderLine(13, 22);
   GotoXY(8, 14); Write('[');
   GotoXY(9, 14);
   For I := 0 to 63 do                                  { Print secure data } 
         If DBuff[I] > $1F then Write(Char(DBuff[I])) else Write('.');
   Write(']');
End;

Var
   DBuffS : Array[0..63] of Byte;
   SPass  : Array[0..7] of Byte;

Procedure GetBlockNumber;

Begin
   Repeat
      GotoXY(20, 18);
      Write('PLEASE ENTER DESIRED BLOCK NUMBER (0 - 8) ');
      BlockNum := Byte(ReadKey);
      If BlockNum = 0 then Begin
         If Byte(ReadKey) = ALTH then Begin
            BlockPageHelp;
            BlockMenu;
            If PrintScratchPadData then;
            For I := 0 to 7 do DBuff[I + 8] := SPass[I];
            If ReadSubKey(KeyNum) then;
            PrintSecureData;
            GotoXY(20, 18);
            Write('PLEASE ENTER DESIRED BLOCK NUMBER (0 - 8) ');
         End;
         BlockNum := 9;                       { Set an invalid block number }
      End Else If BlockNum <> ESC then BlockNum := BlockNum - 48;
   Until ((BlockNum < 9) Or (BlockNum = ESC));
End;

Procedure GetPassword;

Var
   KSP, LPLC : Byte;

Begin
   LPLC := 8;                            { Initialize index into data array }
   NoALTH;
   GotoXY(15, 10);
   Write('PLEASE ENTER PASSWORD FOR SECURE SUBKEY #', KeyNum,' [        ]');
   GotoXY(59, 10);
   For I := 8 to 15 do DBuff[I] := $20;
   Repeat
      KSP := Byte(ReadKey);                                 { Get keystroke }
      If KSP = 0 then Begin            { Was an ALT or FUNCTION key pressed }
         JB := Byte(ReadKey);                 { If so soak up bad keystroke }
         Write(Char(7));                       { Warn user of bad keystroke }
      End else Begin
         If KSP = BKSP then Begin
            If LPLC > 8 then Begin
               Dec(LPLC);
               Write(Char(BKSP), ' ', Char(BKSP));
            End else Write(Char(7)); 
         End else If KSP <> CR then Begin
            If LPLC < 16 then Begin
               DBuff[LPLC] := KSP;
               Inc(LPLC);
               Write(Char(KSP));
            End else Write(Char(7));
         End; 
      End;
   Until (KSP = CR);
   ResALTH;
End;

Procedure KeyPage;

Const
   XK  : Array[0..2] of Byte = ( 36, 36, 17 );
   YK  : Array[0..2] of Byte = ( 8, 12, 16 ); 
   MAX : Array[0..2] of Byte = ( 8, 8, 48 ); 

Var
   KSS, X, Y, ClrNum, KPLC, DPLC, PKeeper : Byte;
   NewID, BR : Boolean;

Begin
   BlockMenu;
   GetKeyNum;  
   For I := 0 to 7 do DBuff[I + 8] := PasData[KeyNum, I + 1]; 
   If ReadSubKey(KeyNum) then Begin
      PrintRomData;                             { Display DS14x5's ROM data }
      If ReadAndDisp(KeyNum) then;{ Read/display data of secure key #KeyNum }
      NewID := False;
      KPLC := 0; PKeeper := 0; DPLC := 0; KSS := 0;
      While KSS <> ESC do Begin
         KSS := Byte(ReadKey);
         If KSS = 0 then Begin
            KSS := Byte(ReadKey);
            Case KSS of
               UPARR: Begin
                  If PKeeper = 0 then Begin
                     If KPLC = 0 then KPLC := 2 Else Dec(KPLC);
                     DPLC := 8 * KPLC;
                     GotoXY(XK[KPLC], YK[KPLC]);
                  End;
               End;
               DNARR: Begin
                  If PKeeper = 0 then Begin
                     If KPLC < 2 then Inc(KPLC) Else KPLC := 0;
                     DPLC := 8 * KPLC;
                     GotoXY(XK[KPLC], YK[KPLC]);
                  End;
               End;
               ALTH: Begin
                  KeyPageHelp;
                  PrintRomData;                             
                  If ReadAndDisp(KeyNum) then;    
                  NewID := False;
                  KPLC := 0; PKeeper := 0; DPLC := 0;
               End;
            End;
         End else Begin
            If KSS = BKSP then Begin
               If PKeeper > 0 then Begin
                  Dec(PKeeper);
                  Dec(DPLC);
                  Write(Char(BKSP), ' ', Char(BKSP));  
               End else Write(Char(7));
            End else if KSS = CR then Begin
               Case KPLC of
                  0: Begin
                     GotoXY(XK[1], YK[1]);
                     For I := 8 to 15 do Begin
                        Write(' ');
                        DBuff[I] := $20;
                     End;
                     GotoXY(XK[2], YK[2]);
                     For I := 16 to 63 do Begin
                        Write(' ');
                        DBuff[I] := $20;
                     End;
                     KPLC := 1;
                     GotoXY(XK[KPLC], YK[KPLC]);
                     PKeeper := 0;
                     DPLC := 8;
                     NewID := True;
                  End;
                  1: Begin
                     If NewID then BR := ReProgramSubKey(KeyNum); 
                     If (Not ReadAndDisp(KeyNum)) then Begin
                        GotoXY(1, 5);
                        Center('NO DS14X5s PRESENT');
                        GotoXY(28, 6);
                        Write('PRESS ANY KEY TO CONTINUE');
                        KSS := Byte(ReadKey);
                        If KSS = 0 then KSS := Byte(ReadKey); 
                        Exit;
                     End;
                     PKeeper := 0;
                     If NewID then KPLC := 2 Else KPLC := 0;
                     GotoXY(XK[KPLC], YK[KPLC]);
                     If NewID then DPLC := 16 Else DPLC := 0;
                     NewID := False;
                  End;
                  2: Begin
                     If (Not(WriteSubKey(KeyNum) 
                         And ReadAndDisp(KeyNum))) then Begin
                        GotoXY(1, 5);
                        Center('NO DS14X5s PRESENT');
                        GotoXY(28, 6);
                        Write('PRESS ANY KEY TO CONTINUE');
                        KSS := Byte(ReadKey);
                        If KSS = 0 then KSS := Byte(ReadKey); 
                        Exit;
                     End;
                     KPLC := 0; PKeeper := 0;
                     GotoXY(XK[KPLC], YK[KPLC]);
                     DPLC := 0;
                  End; 
               End;
            End else if KSS <> ESC then Begin
               If PKeeper = 0 then Begin
                  X := WhereX; Y := WhereY;  
                  If KPLC = 2 then ClrNum := 48 Else ClrNum := 8;
                  For I := 0 to ClrNum - 1 do Begin
                     Write(' ');
                     DBuff[DPLC + I] := $20;
                  End;
                  GotoXY(X, Y);
               End;
               If PKeeper < Max[KPLC] then Begin
                  Write(Char(KSS));
                  DBuff[DPLC] := KSS;
                  Inc(DPLC);
                  Inc(PKeeper);
               End else Write(Char(7));
            End;
         End;
      End;
   End else Begin
      GotoXY(1, 5);
      Center('NO DS14X5s PRESENT');
      GotoXY(28, 6);
      Write('PRESS ANY KEY TO CONTINUE');
      KSS := Byte(ReadKey);
      If KSS = 0 then KSS := Byte(ReadKey); 
   End;
End;

Procedure MoveBlockPage;

Begin
   BlockMenu;
   GetKeyNum;
   GetPassword;
   For I := 0 to 7 do SPass[I] := DBuff[I + 8];
   If ReadSubKey(KeyNum) then;
   For I := 0 to 63 do DBuffS[I] := DBuff[I];
   If PrintScratchPadData then Begin
      For I := 0 to 63 do DBuff[I] := DBuffS[I];
      PrintSecureData;
      GetBlockNumber;
      If BlockNum = ESC then Exit;
      If TransferBlock(KeyNum, BlockNum) then;
      InitMainWin;
      If PrintScratchPadData then;
      For I := 0 to 7 do DBuff[I + 8] := SPass[I];
      If ReadSubKey(KeyNum) then;  
      PrintSecureData;
      BlockExit;
   End else Begin
      GotoXY(1, 5);
      Center('NO DS14X5s PRESENT');
      GotoXY(28, 6);
      Write('PRESS ANY KEY TO CONTINUE');
      If Byte(ReadKey) = 0 then JB := Byte(ReadKey);
   End;
End;

Var
   Num_Found, KS : Byte;
   PFound        : Boolean;
   K             : Boolean;
Begin                                             { Main program begins here }
   PFound := False;
   PN := 0;                                       { Search ports for DOW parts }

   K := DowCheck;                                 { Initilize the DOW }

   While ((Not PFound) And (PN < 4)) do Begin
      Inc(PN);
      If Setup(PN) then If KeyOpen then If GndTest then If First then PFound := True;
      K := KeyClose;
   End;
   If Not PFound then Begin
      WriteLn('No DS14x5s found on any LPT port\n');
      Halt;
   End; 

   Num_Found := DS14x5s;                  { Find all DS14x5s on LPT port #pn }
   If (Num_Found > 0) then Begin
      Init_Scr(Num_Found);
      Print_Menu;
      FirstDS14x5;                       { Select first part on LPT port #pn }
      PrintRomData;                      { Print the selected parts ROM data }
      For I := 0 to 2 do For J := 1 to 8 do PasData[I, J] := $20;
      While True do Begin
         If KeyPressed then Begin
            KS := Byte(ReadKey);
            Case KS of
               ESC: Begin
                  Window(1, 1, 80, 25);
                  ClrScr;
                  Halt;
               End;
               0: Begin
                  KS := Byte(ReadKey);
                  Case KS of 
                     F1: Begin
                        ScratchPage;
                        InitMainWin;      { Clear the main window of display }
                        Print_Menu;                    { Print the main menu }
                        PrintRomData;      { Print ROM data of selected part }
                     End;
                     F2: Begin
                        KeyPage;    
                        InitMainWin;      { Clear the main window of display }
                        Print_Menu;                    { Print the main menu }
                        PrintRomData;      { Print ROM data of selected part }
                     End;
                     F3: Begin
                        MoveBlockPage;
                        InitMainWin;      { Clear the main window of display }
                        Print_Menu;                    { Print the main menu }
                        PrintRomData;      { Print ROM data of selected part }
                     End;
                     RARR: Begin
                        If FindNextDS14x5 then PrintRomData Else Begin
                           Window(1, 1, 80, 25);
                           ClrScr;
                           WriteLn('No DS14x5s Found'); 
                           Halt;
                        End;
                     End;
                     ALTH: Begin
                        MainHelpPage;                    { Print help screen }
                        InitMainWin;      { Clear the main window of display }
                        Print_Menu;                    { Print the main menu }
                        PrintRomData;      { Print ROM data of selected part }
                     End;
                  End;
               End;
            End; 
         End;
      End;
   End Else WriteLn('No DS14x5''s found');
End.



