DECLARE SUB MainMenu ()
DECLARE SUB PrintRomData ()
DECLARE SUB ScratchPage ()
DECLARE SUB KeyPage ()
DECLARE SUB MoveBlockPage ()
DECLARE SUB MainHelpPage ()
DECLARE SUB ScratchPageHelp ()
DECLARE SUB NewMenu ()
DECLARE SUB GetKeyNum ()
DECLARE SUB KeyPageHelp ()
DECLARE SUB GetPassword ()
DECLARE SUB PrintSecureData ()
DECLARE SUB GetBlockNumber ()
DECLARE SUB BlockPageHelp ()
DECLARE SUB InitScr ()
DECLARE SUB Center (S$)
DECLARE SUB CenterH (S$)
DECLARE SUB DS14x5s ()
DECLARE SUB FirstDS14x5 ()
DECLARE SUB UnderLine (YCoord%, Length%)
DECLARE FUNCTION NDS14X5% ()
DECLARE FUNCTION ReadScratchPad% ()
DECLARE FUNCTION WriteScratchPad% ()
DECLARE FUNCTION ReadSubKey% (KeyNum%)
DECLARE FUNCTION WriteSubKey% (KeyNum%)
DECLARE FUNCTION ReprogramSubKey% (KeyNum%)
DECLARE FUNCTION TransferBlock% (KeyNum%, BlockNum%)
DECLARE FUNCTION DisScratchPadData% ()
DECLARE FUNCTION ReadAndDisp% (KeyNum%)
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  Sample.bas                                                              '
'  DS Software Authorization SDK 4.3                                       ' 
'  Disk 1 - Dos Object & Source Files                                      ' 
'  02/13/98                                                                '
'                                                                          '
' Copyright (C) 1996 Dallas Semiconductor Corporation.                     '
' All rights Reserved.  Printed in U.S.A.                                  '
' This software is protected by copyright laws of the United States and of '
' foreign countries.  This software is furnished under a license agreement '
' and/or a nondisclosure agreement and may only be used or copied in       '
' accordance with the terms of those agreements.  The mere transfer of     '
' this software does not imply any licenses of trade secrets, proprietary  '
' technology, copyrights, patents, trademarks, maskwork rights, or any     '
' other form of intellectual property whatsoever. Dallas Semiconductor     '
' retains all ownership rights.                                            '
'                                                                          ' 
' Notes:                                                                   ' 
'                                                                          ' 
'      This program calls the access system contained in sauthasm.obj      ' 
'      for low level communication with the DOW (Dallas 1-wire) parts.     ' 
'                                                                          '
'      This was compilled using Microsoft Quickbasic (ver 4.5).            ' 
'                                                                          ' 
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
DIM DBuff%(64)
DIM Password%(3, 8)
DIM MBLKS%(9, 8)
DIM SPass%(8)
'
COMMON SHARED DBuff%(), Password%(), MBLKS%(), SPass%()
COMMON SHARED PN%                                            ' LPT port number
COMMON SHARED NumFound%
COMMON SHARED PLC%
COMMON SHARED KeyNum%, BlockNum%
'
PFound% = 0: PN% = 0                         ' Search ports to find a DOW part

CALL BDowcheck(ANS%)                         ' Initialize DOW

DO WHILE ((PFound% = 0) AND (PN% < 3))
   PN% = PN% + 1
   CALL BSetup(PN%, ANS%)                          ' Search for port existance
   IF ANS% = 1 THEN
	  CALL BKeyOpen
	  CALL BGndtest(ANS%)              ' If printer is attached, is it on line
	  IF ANS% = 1 THEN
		 CALL BFirst(ANS%)                               ' Look for a DOW part
		 IF ANS% = 1 THEN PFound% = 1                        ' Set TRUE result
	  END IF
	  CALL BKeyClose
   END IF
LOOP

IF PFound% = 0 THEN        ' Tell user we didn't find any DOW parts on the bus
   PRINT "NO DS14X5s FOUND ON ANY LPT PORT"
   STOP
END IF

LOCATE , , 1, 0, 7
FOR I% = 0 TO 2                         ' Initialize password fields to spaces
   FOR J% = 0 TO 7
	  Password%(I%, J%) = &H20
   NEXT J%
NEXT I%

FOR I% = 0 TO 8
   FOR J% = 0 TO 7
	  READ MBLKS%(I%, J%)
   NEXT J%
NEXT I%

CALL BKeyOpen(ANS%)       ' Get control of the port

CALL DS14x5s              ' Make sure atleast 1 of the DOW devices is a DS14x5
IF NumFound% > 0 THEN
   CALL InitScr
   CALL MainMenu
   CALL FirstDS14x5
   CALL PrintRomData
   KS% = 0
   DO WHILE KS% <> 27
	  CALL GetKS(KS%)
	  IF KS% = 0 THEN
		 CALL GetKS(KS%)
		 IF KS% = 59 THEN                         ' F1 Read / Write scratchpad
			CALL ScratchPage
			CALL MainMenu
			CALL PrintRomData
		 END IF
		 IF KS% = 60 THEN                            ' F2 Read / Write subkeys
			CALL KeyPage
			CALL MainMenu
			CALL PrintRomData
		 END IF
		 IF KS% = 61 THEN                                     ' F3 Move Blocks
			CALL MoveBlockPage
			CALL MainMenu
			CALL PrintRomData
		 END IF
		 IF KS% = 77 THEN                  ' Right arrow key, find next DS14x5
			IF NDS14X5% = 1 THEN
			   CALL PrintRomData
			ELSE
			   CLS
			   PRINT "NO DS14X5s CURRENTLY ON LPT PORT #"; PN%
			   STOP
			END IF
		 END IF
		 IF KS% = 35 THEN                  ' ALT-H, help information requested
			CALL MainHelpPage
			CALL MainMenu
			CALL PrintRomData
		 END IF
	  ELSE
		 IF KS% = 27 THEN
			CLS
		 ELSE
			PRINT CHR$(&H7)
		 END IF
	  END IF

	  CALL BKeyClose(ANS%)               ' Release control of port between passes
	  CALL BKeyOpen(ANS%)                ' Regain control of port

   LOOP
ELSE
   PRINT "NO DS14X5s FOUND ON LPT PORT WHERE FIRST DOW DEVICE FOUND"
   STOP
END IF
CALL BKeyClose(ANS%)                     ' Release control of port before exit
'
'    Move Block selector codes for the TransferBlock% function below.
'
DATA &H9A, &H9A, &HB3, &H9D, &H64, &H6E, &H69, &H4C
DATA &H9A, &H9A, &H4C, &H62, &H9B, &H91, &H69, &H4C
DATA &H9A, &H65, &HB3, &H62, &H9B, &H6E, &H96, &H4C
DATA &H6A, &H6A, &H43, &H6D, &H6B, &H61, &H66, &H43
DATA &H95, &H95, &HBC, &H92, &H94, &H9E, &H99, &HBC
DATA &H65, &H9A, &H4C, &H9D, &H64, &H91, &H69, &HB3
DATA &H65, &H65, &HB3, &H9D, &H64, &H6E, &H96, &HB3
DATA &H65, &H65, &H4C, &H62, &H9B, &H91, &H96, &HB3
DATA &H56, &H56, &H7F, &H51, &H57, &H5D, &H5A, &H7F



SUB BlockPageHelp

   CLS
   CenterH ("MOVE BLOCK")
   CALL UnderLine(2, 10)
   PRINT
   CenterH ("   This portion of the demonstration program performs the move")
   CenterH ("block function of the DS14x5. This function moves a block of  ")
   CenterH ("the scratchpad into the specified secure subkey. For a block  ")
   CenterH ("move to occur, the password of the specified subkey MUST be   ")
   CenterH ("correct. Once a move block has occurred the data in the       ")
   CenterH ("scratchpad (only the block that was transferred) will be      ")
   CenterH ("cleared by the DS14x5.                                        ")
   CenterH ("   There are nine valid blocks to choose from. Block numbers  ")
   CenterH ("0-7 are on eight byte boundaries starting at address 0 in the ")
   CenterH ("scratchpad (ex. specifying block 2 will move bytes 16 - 23 of ")
   CenterH ("the scratchpad into the specified secure subkey). Block 8     ")
   CenterH ("transfers the entire contents of the scratchpad into the      ")
   CenterH ("specified subkey.                                             ")
   LOCATE 23, 37
   PRINT "<MORE> ";
   CALL GetKS(HKS%)
   IF HKS% = 0 THEN CALL GetKS(HKS%)
   CLS
   CenterH ("MOVE BLOCK")
   CALL UnderLine(2, 10)
   PRINT
   CenterH ("   Please note that if move block 1 or move block 8 is per-   ")
   CenterH ("formed the new password of the secure subkey will be equal to ")
   CenterH ("bytes 8 - 15 of the scratchpad. Therefore unless the original ")
   CenterH ("password equals those scratchpad bytes, the data in the secure")
   CenterH ("data field will be random (since the supplied password has    ")
   CenterH ("been changed). To verify the move block took place go to the  ")
   CenterH ("secure subkey portion of the demo (by pressing F2 from the    ")
   CenterH ("main screen) and supply the new password.                     ")
   LOCATE 23, 27
   PRINT "PRESS ANY KEY TO CONTINUE ";
   CALL GetKS(HKS%)
   IF HKS% = 0 THEN CALL GetKS(HKS%)

END SUB

SUB Center (S$)

  LOCATE CSRLIN, INT(80 - LEN(S$)) / 2
  PRINT S$;

END SUB

SUB CenterH (S$)

  LOCATE CSRLIN, INT(80 - LEN(S$)) / 2
  PRINT S$

END SUB

FUNCTION DisScratchPadData%

   IF ReadScratchPad% = 1 THEN
	  CALL NewMenu
	  CALL PrintRomData
	  LOCATE 11, 1
	  Center ("SCRATCHPAD DATA")
	  CALL UnderLine(12, 15)
	  LOCATE 13, 8: PRINT "[";
	  FOR I% = 0 TO 63
		 IF DBuff%(I%) < &H20 THEN
			PRINT ".";
		 ELSE
			PRINT CHR$(DBuff%(I%));
		 END IF
	  NEXT I%
	  PRINT "]";
	  DisScratchPadData% = 1
   ELSE
	  DisScratchPadData% = 0
   END IF

END FUNCTION

SUB DS14x5s

   NumFound% = 0
   CALL BFirst(ANS%)
   DO WHILE ANS% = 1
	  CALL BRomData(Segment%, Offset%)       ' Get pointer to 8 byte ROM buffer
	  DEF SEG = Segment%
		 IF PEEK(Offset%) = &H82 THEN 
                    NumFound% = NumFound% + 1
                 ELSE  
                    IF PEEK(Offset%) = &H02 THEN 
                       NumFound% = NumFound% +1
                    END IF
                 END IF
	  DEF SEG
	  CALL BNext(ANS%)
   LOOP

END SUB

SUB FirstDS14x5

   Res% = 0: Pass% = 0
   CALL BFirst(ANS%)                                     ' Get first DOW device
   DO WHILE (Res% = 0) AND (Pass% = 0)
	  CALL BRomData(Segment%, Offset%)       ' Get pointer to 8 byte ROM buffer
	  DEF SEG = Segment%
		 IF PEEK(Offset%) = &H82 THEN 
                    Res% = 1            ' Look at family code
                 ELSE
                    IF PEEK(Offset%) = &H02 THEN Res% = 1
                 END IF
	  DEF SEG
	  IF Res% = 0 THEN
		 CALL BNext(ANS%)
		 IF ANS% = 0 THEN Pass% = 1
	  END IF
   LOOP
 
END SUB

SUB GetBlockNumber

   BlockNum% = 9:
   DO WHILE (BlockNum% > 8) AND (BlockNum% <> 27)
	  LOCATE 21, 20
	  PRINT "PLEASE ENTER DESIRED BLOCK NUMBER (0 - 8) ";
	  CALL GetKS(BlockNum%)
	  IF BlockNum% = 0 THEN
		 CALL GetKS(KSG%)
		 IF KSG% = 35 THEN                                ' ALT-H was pressed.
			CALL BlockPageHelp
			CALL NewMenu
			JR% = DisScratchPadData%
			FOR I% = 0 TO 7
			   DBuff%(I% + 8) = SPass%(I%)           ' Restore password field.
			NEXT I%
			JR% = ReadSubKey%(KeyNum%)
			CALL PrintSecureData
			LOCATE 21, 20
			PRINT "PLEASE ENTER DESIRED BLOCK NUMBER (0 - 8) ";
		 END IF
		 BlockNum% = 9
	  ELSE
		 IF BlockNum% <> 27 THEN BlockNum% = BlockNum% - 48
	  END IF
   LOOP

END SUB

SUB GetKeyNum

   CLS
   KeyNum% = 3
   DO WHILE KeyNum% > 2
	  LOCATE 5, 22
	  PRINT "PLEASE ENTER DESIRED SUBKEY NUMBER (0 - 2) ";
	  CALL GetKS(KS%)
	  IF KS% = 0 THEN CALL GetKS(KS%) ELSE KeyNum% = KS% - 48
   LOOP
   CALL NewMenu

END SUB

SUB GetPassword

   CLS
   LPLC% = 8
   LOCATE 10, 15
   PRINT "PLEASE ENTER PASSWORD FOR SECURE SUBKEY #"; KeyNum%; " [        ]";
   LOCATE 10, 61
   FOR I% = 8 TO 15
	  DBuff%(I%) = &H20
   NEXT I%
   KSP% = 0
   DO WHILE KSP% <> 13
	  CALL GetKS(KSP%)
	  IF KSP% = 0 THEN
		 CALL GetKS(KSP%)
		 PRINT CHR$(7);
	  ELSE
		 IF KSP% = 8 THEN
			IF LPLC% > 8 THEN
			   LPLC% = LPLC% - 1
			   LOCATE CSRLIN, POS(0) - 1
			   PRINT " ";
			   LOCATE CSRLIN, POS(0) - 1
			ELSE
			   PRINT CHR$(7);
			END IF
		 ELSE
			IF KSP% <> 13 THEN
			   IF LPLC% < 16 THEN
				  DBuff%(LPLC%) = KSP%
				  LPLC% = LPLC% + 1
				  PRINT CHR$(KSP%);
			   ELSE
				  PRINT CHR$(7);
			   END IF
			END IF
		 END IF
	  END IF
   LOOP

END SUB

SUB InitScr

   CLS
   LOCATE 5, 23
   PRINT "NUMBER OF DS14X5s ON LPT PORT #"; PN%; " = "; NumFound%
   LOCATE 20, 1
   Center ("PRESS ANY KEY TO CONTINUE")
   KS% = 0
   DO WHILE KS% = 0
	  CALL GetKS(KS%)
   LOOP
 
END SUB

SUB KeyPage

   DIM XK%(3), YK%(3), Max%(3)

   XK%(0) = 36: XK%(1) = 36: XK%(2) = 17:
   YK%(0) = 13: YK%(1) = 17: YK%(2) = 21:
   Max%(0) = 8: Max%(1) = 8: Max%(2) = 48:

   CALL NewMenu
   CALL GetKeyNum                                        ' Get desired subkey.
   FOR I% = 8 TO 15
	  DBuff%(I%) = Password%(KeyNum%, I% - 8)     ' Initialize password field.
   NEXT I%
   IF ReadSubKey%(KeyNum%) = 1 THEN
	  CALL PrintRomData                           ' display DS14x5's ROM data.
	  JR% = ReadAndDisp%(KeyNum%) 'Read secure subkey and display secure data.
	  NewID% = 0: PLC% = 0: KPLC% = 0: PKeeper% = 0
	  LOCATE YK%(KPLC%), XK%(KPLC%)
	  KS% = 0
	  DO WHILE KS% <> 27
		 CALL GetKS(KS%)
		 IF KS% = 0 THEN
			CALL GetKS(KS%)
			IF KS% = 72 THEN                            ' Up arrow key pressed
			   IF PKeeper% = 0 THEN
				  IF KPLC% = 0 THEN KPLC% = 2 ELSE KPLC% = KPLC% - 1
				  PLC% = 8 * KPLC%
				  LOCATE YK%(KPLC%), XK%(KPLC%)
			   END IF
			END IF
			IF KS% = 80 THEN                          ' Down arrow key pressed
			   IF PKeeper% = 0 THEN
				  IF KPLC% < 2 THEN KPLC% = KPLC% + 1 ELSE KPLC% = 0
				  PLC% = 8 * KPLC%
				  LOCATE YK%(KPLC%), XK%(KPLC%)
			   END IF
			END IF
			IF KS% = 35 THEN                               ' ALT-H key pressed
			   CALL KeyPageHelp
			   CALL PrintRomData
			   JR% = ReadAndDisp%(KeyNum%)
			   NewID% = 0: PLC% = 0: KPLC% = 0: PKeeper% = 0
			   LOCATE YK%(KPLC%), XK%(KPLC%)
			END IF
		 ELSE
			IF KS% = 8 THEN
			   IF PKeeper% > 0 THEN
				  PKeeper% = PKeeper% - 1
				  PLC% = PLC% - 1
				  LOCATE CSRLIN, POS(0) - 1
				  PRINT " ";
				  LOCATE CSRLIN, POS(0) - 1
			   ELSE
				  PRINT CHR$(7);
			   END IF
			ELSE
			   IF KS% = 13 THEN
				  IF KPLC% = 0 THEN
					 LOCATE YK%(1), XK%(1)
					 FOR I% = 8 TO 15
						PRINT " ";
						DBuff%(I%) = &H20
					 NEXT I%
					 LOCATE YK%(2), XK%(2)
					 FOR I% = 16 TO 63
						PRINT " ";
						DBuff%(I%) = &H20
					 NEXT I%
					 KPLC% = 1
					 LOCATE YK%(KPLC%), XK%(KPLC%)
					 PKeeper% = 0
					 PLC% = 8
					NewID% = 1
				  ELSE
					 IF KPLC% = 1 THEN
						IF NewID% = 1 THEN JR% = ReprogramSubKey%(KeyNum%)
						JR% = ReadAndDisp%(KeyNum%)
						PKeeper% = 0
						IF NewID% = 1 THEN KPLC% = 2 ELSE KPLC% = 0
						LOCATE YK%(KPLC%), XK%(KPLC%)
						IF NewID% = 1 THEN PLC% = 16 ELSE PLC% = 0
						NewID% = 0
					 ELSE
						IF KPLC% = 2 THEN
						   JR% = WriteSubKey%(KeyNum%)
						   JR% = ReadAndDisp%(KeyNum%)
						   KPLC% = 0: PKeeper% = 0: PLC% = 0
						   LOCATE YK%(KPLC%), XK%(KPLC%)
						END IF
					 END IF
				  END IF
			   ELSE
				  IF PKeeper% = 0 THEN
					 IF KPLC% = 2 THEN ClrNum% = 48 ELSE ClrNum% = 8
					 PLCS% = PLC%
					 FOR I% = 0 TO ClrNum% - 1
						PRINT " ";
						DBuff%(PLC%) = &H20
						PLC% = PLC% + 1
					 NEXT I%
					 LOCATE YK%(KPLC%), XK%(KPLC%)
					 PLC% = PLCS%
				  END IF
				  IF PKeeper% < Max%(KPLC%) THEN
					 PRINT CHR$(KS%);
					 DBuff%(PLC%) = KS%
					 PLC% = PLC% + 1
					 PKeeper% = PKeeper% + 1
				  ELSE
					 PRINT (CHR$(7));
				  END IF
			   END IF
			END IF
		 END IF
	  LOOP
   ELSE
	  CLS
	  LOCATE 5, 24
	  PRINT "NO DS14x5s PRESENT, PRESS ANY KEY ";
	  CALL GetKS(KS%)
	  IF KS% = 0 THEN CALL GetKS(KS%)
   END IF

END SUB

SUB KeyPageHelp

   CLS
   CenterH ("READ/WRITE SECURE SUBKEY")
   CALL UnderLine(2, 26)
   PRINT
   CenterH ("   This part of the demonstration allows you to READ/WRITE one of")
   CenterH ("3 secure subkeys of the currently addressed DS14x5. Please note  ")
   CenterH ("that the password field of any DS14x5 is WRITE only memory. There")
   CenterH ("is NO way to read this field from the device. For this reason    ")
   CenterH ("SAMPLE will assume a password of all spaces. This is almost cer- ")
   CenterH ("tainly an incorrect password, and therefore the data read from   ")
   CenterH ("the secure data field is random data (the false password seeds   ")
   CenterH ("the DS14X5's intelligent response generator). If you know the    ")
   CenterH ("correct password, go to the password field (via the up and down  ")
   CenterH ("arrow keys) and type in the password and press enter. You will   ")
   CenterH ("then see your secure data displayed.                             ")
   CenterH ("   If data is entered into the secure data field when the data   ")
   CenterH ("in the password field is incorrect the write will fail, and the  ")
   CenterH ("random data will be returned. If the password is correct the     ")
   CenterH ("device will accept the new secure data.                          ")
   LOCATE 23, 37
   PRINT "<MORE> ";
   CALL GetKS(HKS%)
   IF HKS% = 0 THEN CALL GetKS(HKS%)
   CLS
   CenterH ("READ/WRITE SECURE SUBKEY")
   CALL UnderLine(2, 26)
   PRINT
   CenterH ("   To change the password, type in a new ID field and press      ")
   CenterH ("<ENTER>. Next type in your new password and press <ENTER>. You   ")
   CenterH ("will notice all periods in the secure data field. This is due to ")
   CenterH ("the fact that after the password is changed the part clears the  ")
   CenterH ("secure data field(fills it with binary 0's). Since 0 is not a    ")
   CenterH ("printable byte, SAMPLE substitutes periods for the display. Next ")
   CenterH ("the secure data field can be reprogrammed.                       ")
   LOCATE 23, 27
   PRINT "PRESS ANY KEY TO CONTINUE ";
   CALL GetKS(HKS%)
   IF HKS% = 0 THEN CALL GetKS(HKS%)

END SUB

SUB MainHelpPage

   CLS
   CenterH ("MAIN SCREEN")
   CALL UnderLine(2, 11)
   PRINT
   CenterH ("   This screen displays the unique serial number of the DS1405/")
   CenterH ("DS1425 that is currently being addressed. If multiple DS14x5s  ")
   CenterH ("are present on the currently selected LPT port, another DS14x5 ")
   CenterH ("may be addressed by pressing the right arrow key until the     ")
   CenterH ("desired DS14x5's serial number is displayed on the screen.     ")
   CenterH ("   After the desired DS14x5 has been selected you may exercise ")
   CenterH ("any of its RAM functions by pressing the function key specified")
   CenterH ("on the last line of the display. Please note that seperate help")
   CenterH ("information is available for every part of this demonstration. ")
   CenterH ("   On any screen of this demo, pressing the escape key will    ")
   CenterH ("allow you to return to the previous screen.                    ")
   LOCATE 23, 27
   PRINT "PRESS ANY KEY TO CONTINUE ";
   CALL GetKS(HKS%)
   IF HKS% = 0 THEN CALL GetKS(HKS%)

END SUB

SUB MainMenu

   COLOR 14, 1
   CLS
   LOCATE 1, 1
   Center ("DALLAS SEMICONDUCTOR DS14X5 DEMONSTRATION PROGRAM")
   LOCATE 3, 1
   Center ("PRESS <ALT-H> FOR HELP")
   LOCATE 23, 1
   Center ("PRESS RIGHT ARROW KEY TO ADDRESS NEXT DS14X5")
   LOCATE 24, 1
   Center ("PRESS <ESC> TO EXIT")
   LOCATE 25, 1
   Center ("F1 READ/WRITE SCRATCHPAD  F2 READ/WRITE SUBKEYS  F3 MOVE BLOCKS")

END SUB

SUB MoveBlockPage

   DIM DBuffS%(64)

   CALL GetKeyNum
   CALL GetPassword
   FOR I% = 0 TO 7
	  SPass%(I%) = DBuff%(I% + 8)
   NEXT I%
   JR% = ReadSubKey%(KeyNum%)
   FOR I% = 0 TO 63
	  DBuffS%(I%) = DBuff%(I%)
   NEXT I%
   IF DisScratchPadData% = 1 THEN
	  FOR I% = 0 TO 63
		 DBuff%(I%) = DBuffS%(I%)
	  NEXT I%
	  CALL PrintSecureData
	  CALL GetBlockNumber
	  IF BlockNum% <> 27 THEN
		 JR% = TransferBlock%(KeyNum%, BlockNum%)
		 CALL NewMenu
		 JR% = DisScratchPadData%
		 FOR I% = 0 TO 7
			DBuff%(I% + 8) = SPass%(I%)
		 NEXT I%
		 JR% = ReadSubKey%(KeyNum%)
		 CALL PrintSecureData
		 LOCATE 24, 59
		 KS% = 0
		 DO WHILE KS% <> 27
			CALL GetKS(KS%)
		 LOOP
	  END IF
   ELSE
	  CLS
	  LOCATE 5, 24
	  PRINT "NO DS14x5s PRESENT, PRESS ANY KEY ";
	  CALL GetKS(KS%)
	  IF KS% = 0 THEN CALL GetKS(KS%)
   END IF

END SUB

FUNCTION NDS14X5%

   SB% = 0: OP% = 0
   DO WHILE (SB% = 0) AND (OP% < 2)
	  CALL BNext(ANS%)
	  IF ANS% = 1 THEN
		 CALL BRomData(Segment%, Offset%)
		 DEF SEG = Segment%
			IF PEEK(Offset%) = &H82 THEN SB% = 1
                        IF PEEK(Offset%) = &H02 THEN SB% = 1
		 DEF SEG
	  ELSE
		 OP% = OP% + 1
		 CALL BFirst(ANS%)
		 IF ANS% = 1 THEN
			CALL BRomData(Segment%, Offset%)
			DEF SEG = Segment%
			   IF PEEK(Offset%) = &H82 THEN SB% = 1
                           IF PEEK(Offset%) = &H02 THEN SB% = 1
			DEF SEG
		 END IF
	  END IF
   LOOP
   NDS14X5% = SB%

END FUNCTION

SUB NewMenu

   CLS
   LOCATE 1, 1
   Center ("DALLAS SEMICONDUCTOR DS14X5 DEMONSTRATION PROGRAM")
   LOCATE 3, 1
   Center ("PRESS <ALT-H> FOR HELP")
   LOCATE 24, 1
   Center ("PRESS <ESC> TO RETURN TO MAIN SCREEN")

END SUB

SUB PrintRomData

   LOCATE 7, 1
   Center ("UNIQUE LASERED SERIAL NUMBER OF SELECTED DS14X5")
   CALL UnderLine(8, 47)
   LOCATE 9, 29
   CALL BRomData(Segment%, Offset%)
   DEF SEG = Segment%
	  FOR I% = 0 TO 7
		 IF PEEK(Offset% + I%) < &HF THEN PRINT "0";
		 PRINT HEX$(PEEK(Offset% + I%)); " ";
	  NEXT I%
   DEF SEG

END SUB

SUB PrintSecureData
   
   LOCATE 17, 1
   Center ("SELECTED SUBKEY'S DATA")
   CALL UnderLine(18, 22)
   LOCATE 19, 8: PRINT "[";
   LOCATE 19, 9
   FOR I% = 0 TO 63
	  IF DBuff%(I%) > &H1F THEN PRINT CHR$(DBuff%(I%));  ELSE PRINT ".";
   NEXT I%
   PRINT "]";

END SUB

FUNCTION ReadAndDisp% (KeyNum%)

   IF ReadSubKey%(KeyNum%) = 1 THEN
	  CALL NewMenu
	  CALL PrintRomData
	  LOCATE 11, 29
	  PRINT "ID FIELD OF SUBKEY #"; KeyNum%
	  CALL UnderLine(12, 22)
	  LOCATE 13, 35
	  PRINT "[";
	  FOR I% = 0 TO 7
		 IF DBuff%(I%) < &H20 THEN PRINT ".";  ELSE PRINT CHR$(DBuff%(I%));
	  NEXT I%
	  PRINT "]";
	  LOCATE 15, 26
	  PRINT "PASSWORD FIELD OF SUBKEY #"; KeyNum%
	  CALL UnderLine(16, 28)
	  LOCATE 17, 35
	  PRINT "[";
	  FOR I% = 8 TO 15
		 IF DBuff%(I%) < &H20 THEN PRINT ".";  ELSE PRINT CHR$(DBuff%(I%));
	  NEXT I%
	  PRINT "]";
	  LOCATE 19, 24
	  PRINT "SECURE DATA FIELD OF SUBKEY #"; KeyNum%
	  CALL UnderLine(20, 31)
	  LOCATE 21, 16
	  PRINT "[";
	  FOR I% = 16 TO 63
		 IF DBuff%(I%) < &H20 THEN PRINT ".";  ELSE PRINT CHR$(DBuff%(I%));
	  NEXT I%
	  PRINT "]";
	  ReadAndDisp% = 1
   ELSE
	  ReadAndDisp% = 0
   END IF

END FUNCTION

FUNCTION ReadScratchPad%
'
'   This function reads the scratchpad of the DS14x5 currenty selected.
'
   CALL BAccess(ANS%)             ' Begin communication with seclected DS14x5.
   IF ANS% = 1 THEN                                  ' Check result of access.
	  CALL BDataByte(&H69, ANS%)               ' Send read scratchpad command.
	  CALL BDataByte(&HC0, ANS%)                      ' Starting at address 0.
	  CALL BDataByte(&H3F, ANS%)      ' Send confirmation of starting address.
	  FOR I% = 0 TO 63
		 CALL BDataByte(&HFF, ANS%)                     ' Read a byte of data.
		 DBuff%(I%) = ANS%                         ' Store byte in data array.
	  NEXT I%
	  ReadScratchPad% = 1                      ' Indicate function successful.
   ELSE
	  ReadScratchPad% = 0                  ' Indicate function not successful.
   END IF

END FUNCTION

FUNCTION ReadSubKey% (KeyNum%)
'
'    This function reads the secure subkey (specified by KeyNum%) data of the
' selected DS14x5.
'
   CALL BAccess(ANS%)
   IF ANS% = 1 THEN
	  CALL BDataByte(&H66, ANS%)                   ' Send read subkey command.
	  CALL BDataByte(KeyNum% * 64 + &H10, ANS%)  ' Specify start addr, subkey.
	  CALL BDataByte((KeyNum% * 64 + &H10) XOR &HFF, ANS%)     ' Confirmation.
	  FOR I% = 0 TO 7
		 CALL BDataByte(&HFF, ANS%)                 ' Read a byte of ID field.
		 DBuff%(I%) = ANS%                         ' Store byte in data array.
	  NEXT I%
	  FOR I% = 8 TO 15
		 CALL BDataByte(DBuff%(I%), ANS%)               ' Send password bytes.
	  NEXT I%
	  FOR I% = 16 TO 63
		 CALL BDataByte(&HFF, ANS%)    ' Read a byte of the secure data field.
		 DBuff%(I%) = ANS%                         ' Store byte in data array.
	  NEXT I%
	  ReadSubKey% = 1
   ELSE
	  ReadSubKey% = 0
   END IF

END FUNCTION

FUNCTION ReprogramSubKey% (KeyNum%)
'
'    This function reprograms the password and ID fields of the selected
' DS14x5. The subkey is specified by KeyNum%.
'
   DIM OldID%(8)

   CALL BAccess(ANS%)
   IF ANS% = 1 THEN
	  CALL BDataByte(&H5A, ANS%)         ' Send reprogram subkey command byte.
	  CALL BDataByte(KeyNum% * 64, ANS%)                     ' Specify subkey.
	  CALL BDataByte((KeyNum% * 64) XOR &HFF, ANS%)  ' Send confirmation byte.
	  FOR I% = 0 TO 7
		 CALL BDataByte(&HFF, ANS%)                     ' Read byte of old ID.
		 OldID%(I%) = ANS%                              ' Save it temporarily.
	  NEXT I%
	  FOR I% = 0 TO 7
		 CALL BDataByte(OldID%(I%), ANS%)               ' Send byte of old ID.
	  NEXT I%
	  FOR I% = 0 TO 7
		 CALL BDataByte(DBuff%(I%), ANS%)               ' Send byte of new ID.
	  NEXT I%
	  FOR I% = 8 TO 15
		 CALL BDataByte(DBuff%(I%), ANS%)         ' Send byte of new password.
	  NEXT I%
	  ReprogramSubKey% = 1
   ELSE
	  ReprogramSubKey% = 0
   END IF

END FUNCTION

SUB ScratchPage

   IF DisScratchPadData% = 1 THEN
	  LOCATE 13, 9
	  KS% = 0: PLC% = 0
	  DO WHILE KS% <> 27
		 CALL GetKS(KS%)
		 IF KS% = 0 THEN
			CALL GetKS(KS%)
			IF KS% = 35 THEN                            ' <ALT-H> was pressed.
			   CALL ScratchPageHelp
			   CALL NewMenu
			   JR% = DisScratchPadData%
			   LOCATE 13, 9
			ELSE
			   PRINT CHR$(7);
			END IF
		 ELSE
			IF KS% = 8 THEN
			   IF PLC% > 0 THEN
				  PLC% = PLC% - 1
				  LOCATE CSRLIN, POS(0) - 1
				  PRINT " ";
				  LOCATE CSRLIN, POS(0) - 1
			   ELSE
				  PRINT CHR$(7);
			   END IF
			ELSE
			   IF KS% = 13 THEN
				  IF (WriteScratchPad% = 1) AND (DisScratchPadData% = 1) THEN
					 LOCATE 13, 9      ' Put cursor back to 1st byte of field.
					 PLC% = 0                             ' Reset array index.
				  ELSE
					 CLS
					 LOCATE 5, 24
					 PRINT "NO DS14x5s PRESENT, PRESS ANY KEY ";
					 CALL GetKS(KS%)
					 IF KS% = 0 THEN CALL GetKS(KS%)
				  END IF
			   ELSE
				  IF PLC% = 0 THEN
					 FOR I% = 0 TO 63
						DBuff%(I%) = &H20
						PRINT " ";
					 NEXT I%
					 LOCATE 13, 9
				  END IF
				  IF PLC% < 64 THEN
					 DBuff%(PLC%) = KS%
					 PRINT CHR$(KS%);
					 PLC% = PLC% + 1
				  ELSE
					 PRINT CHR$(7);
				  END IF
			   END IF
			END IF
		 END IF
	  LOOP
   ELSE
	  CLS
	  LOCATE 5, 24
	  PRINT "NO DS14x5s PRESENT, PRESS ANY KEY ";
	  CALL GetKS(KS%)
	  IF KS% = 0 THEN CALL GetKS(KS%)
   END IF

END SUB

SUB ScratchPageHelp

   CLS
   CenterH ("READ/WRITE SCRATCHPAD")
   CALL UnderLine(2, 21)
   PRINT
   CenterH ("   This screen displays the scratchpad of the currently addressed")
   CenterH ("DS14x5. To write new data into the scratchpad type in new data   ")
   CenterH ("and press <ENTER>. The data you typed will be sent the the DS14x5")
   CenterH ("(the DS14x5 with the serial number displayed on the previous     ")
   CenterH ("screen). Once the data has been written to the DS14x5, it will be")
   CenterH ("read back from the part and displayed.                           ")
   CenterH ("   Please note that even though only ascii data can be entered   ")
   CenterH ("from the keyboard, the scratchpad of the DS14x5 is non-volatile  ")
   CenterH ("RAM and will accept any binary data. For the purposes of display ")
   CenterH ("any non-printable byte read from the part will be displayed as a ")
   CenterH ("period.                                                          ")
   CenterH ("   While this demo treats the scratchpad as a single 512 bit     ")
   CenterH ("entity,this area like the rest of the DS14X5 is byte addressable.")
   LOCATE 23, 27
   PRINT "PRESS ANY KEY TO CONTINUE ";
   CALL GetKS(HKS%)
   IF HKS% = 0 THEN CALL GetKS(HKS%)

END SUB

FUNCTION TransferBlock% (KeyNum%, BlockNum%)
'
'    This function transfers the scratchpad block (specified by BlockNum%) to
' the secure subkey (specified by KeyNum%) of the currenty selected DS14x5.
'
   CALL BAccess(ANS%)
   IF ANS% = 1 THEN
	  CALL BDataByte(&H3C, ANS%)           ' Send transfer block command byte.
	  CALL BDataByte(KeyNum% * 64, ANS%)                     ' Specify subkey.
	  CALL BDataByte((KeyNum% * 64) XOR &HFF, ANS%)  ' Send confirmation byte.
	  FOR I% = 0 TO 7
		 CALL BDataByte(MBLKS%(BlockNum%, I%), ANS%)   ' Send block sel. code.
	  NEXT I%
	  FOR I% = 8 TO 15
		 CALL BDataByte(DBuff%(I%), ANS%)                    ' Send password.
	  NEXT I%
	  TransferBlock% = 1
   ELSE
	  TransferBlock% = 0
   END IF

END FUNCTION

SUB UnderLine (YCoord%, LLen%)

   US$ = ""
   FOR I% = 1 TO LLen%
	  US$ = US$ + CHR$(196)
   NEXT I%
   LOCATE YCoord%, 1
   Center (US$)

END SUB

FUNCTION WriteScratchPad%
'
'   This function reads the scratchpad of the DS14x5 currenty selected.
'
   CALL BAccess(ANS%)             ' Begin communication with seclected DS14x5.
   IF ANS% = 1 THEN                                  ' Check result of access.
	  CALL BDataByte(&H96, ANS%)              ' Send write scratchpad command.
	  CALL BDataByte(&HC0, ANS%)                      ' Starting at address 0.
	  CALL BDataByte(&H3F, ANS%)      ' Send confirmation of starting address.
	  FOR I% = 0 TO 63
		 CALL BDataByte(DBuff%(I%), ANS%)               ' Send a byte of data.
	  NEXT I%
	  WriteScratchPad% = 1                     ' Indicate function successful.
   ELSE
	  WriteScratchPad% = 0                 ' Indicate function not successful.
   END IF

END FUNCTION

FUNCTION WriteSubKey% (KeyNum%)
'
'    This function reads the secure subkey (specified by KeyNum%) data of the
' selected DS14x5.
'
   CALL BAccess(ANS%)
   IF ANS% = 1 THEN
	  CALL BDataByte(&H99, ANS%)                  ' Send write subkey command.
	  CALL BDataByte(KeyNum% * 64 + &H10, ANS%)  ' Specify start addr, subkey.
	  CALL BDataByte((KeyNum% * 64 + &H10) XOR &HFF, ANS%)     ' Confirmation.
	  FOR I% = 0 TO 7
		 CALL BDataByte(&HFF, ANS%)                 ' Read a byte of ID field.
		 DBuff%(I%) = ANS%                         ' Store byte in data array.
	  NEXT I%
	  FOR I% = 8 TO 15
		 CALL BDataByte(DBuff%(I%), ANS%)               ' Send password bytes.
	  NEXT I%
	  FOR I% = 16 TO 63
		 CALL BDataByte(DBuff%(I%), ANS%)'Write byte of the secure data field.
	  NEXT I%
	  WriteSubKey% = 1
   ELSE
	  WriteSubKey% = 0
   END IF

END FUNCTION

