/* ************************************************************************* */
/* Tsample.c                                                                 */
/* DS Software Authorization SDK 4.3                                         */
/* Disk 1 - Dos Object & Source Files                                        */
/* 02/06/98                                                                  */
/*                                                                           */
/* Copyright (C) 1996 Dallas Semiconductor Corporation.                      */
/* All rights Reserved. Printed in U.S.A.                                    */
/* This software is protected by copyright laws of                           */
/* the United States and of foreign countries.                               */
/* This software is furnished under a license agreement and/or a             */
/* nondisclosure agreement and may only be used or copied in accordance      */
/* with the terms of those agreements.                                       */
/* The mere transfer of this software does not imply any licenses            */
/* of trade secrets, proprietary technology, copyrights, patents,            */
/* trademarks, maskwork rights, or any other form of intellectual            */
/* property whatsoever. Dallas Semiconductor retains all ownership rights.   */
/*                                                                           */
/* Additional Notes:                                                         */
/*                                                                           */
/*    This code was compiled using Boreland 4.5 along with the Turbo         */
/*    Assembler.  Use of other compilers may require slight modification.    */
/*                                                                           */
/*    In order to make the project, link this file with either Sauth400.c,   */
/*    or Sauth400.asm.                                                       */
/*                                                                           */
/*    This software is intended for use with DS1410D and DS1410E and later   */
/*    model parallel port adapters only.                                     */
/*                                                                           */
/* ************************************************************************* */

#include<conio.h>
#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<math.h>
#include<ctype.h>
#include<dos.h>

#include"TSAMPLE.H"

void center(char *s)          /* centers a string horizontally on the screen */
{
    gotoxy(((80 - strlen(s)) >> 1) + 1, wherey()); cputs(s);
}

void combar(void)
{
    window(1, 24, 80, 24); textcolor(red); textbackground(gray); clrscr();
}

void banner(void)
{
    window(1, 1, 80, 1); textcolor(red); textbackground(gray); clrscr();
    center("DALLAS SEMICONDUCTOR DS1994/DS1427 DEMO PROGRAM -- SDK VER: 4.3");
}

void textwin(void)
{
    window(1, 2, 80, 23); textbackground(blue); textcolor(yellow);
}

void initcrt(void)
{
    combar();
    center("PGUP, PGDN => CHANGE PAGE        F1 => LEGEND        ESC => QUIT");
    banner();
    textwin();
    clrscr();
}

void help(void)
{
    window(1, 1, 80, 24);
    clrscr();
    gotoxy(1, 4);
    center("   KEYSTROKE                  FUNCTION               ");
    cprintf("\n");
    center("ĳ");
    cprintf("\n");
    center("         ESC                    QUIT                 ");
    cprintf("\n");
    center("       ALT-T  TOGGLE BETWEEN CLOCK AND MEMORY SCREENS");
    cprintf("\n");
    center("     PAGE UP  INCREMENT MEMORY PAGE BEING DISPLAYED  ");
    cprintf("\n");
    center("   PAGE DOWN  DECREMENT MEMORY PAGE BEING DISPLAYED  ");
    cprintf("\n");
    center("  LARR, RARR              CHANGE FIELDS              ");
    cprintf("\n");
    center("  UARR, DARR  NEXT DS1994, PREVIOUS DS1994 ON BUS    ");
    cprintf("\n");
    gotoxy(1, 20);
    center("PRESS ANY KEY TO CONTINUE");
    getch();
}

void warning(void)
{
    window(1, 1, 80, 24);
    clrscr();
    gotoxy(1, 1);
    center("WARNING !!!"); cprintf("\n");
    center(""); cprintf("\n"); cprintf("\n");
    center("   If any of the bits 0 - 2 (WPR, WPE, WPC) in byte 201H");
    cprintf("\n");
    center("are set to ON (1 binary) bits 0 - 4 (WPR, WPE, WPC, RO, ");
    cprintf("\n");
    center("OSC) are PERMANENTLY and IRREVERSIBLY write protected.  ");
    cprintf("\n");
    center("Also if bit 2 (WPC) is set to ON, bit 7 (DSEL) is write ");
    cprintf("\n");
    center("protected.                                              ");
    cprintf("\n");
    center("   If any of bits 0 - 2 are set and bit 3 (RO) is OFF,  ");
    cprintf("\n");
    center("once an alarm occurs only 1's can be read from the part.");
    cprintf("\n");
    center("The bits mentioned above are defined as follows:        ");
    cprintf("\n\n");
    center("           WPR => Write protect real time clock         ");
    cprintf("\n");
    center("           WPE => Write protect elapse timer            ");
    cprintf("\n");
    center("           WPC => Write protect cycle counter           ");
    cprintf("\n");
    center("           RO  => Read only                             ");
    cprintf("\n");
    center("           OSC => Oscillator                            ");
    cprintf("\n");
    center("           DSEL => Delay Select                         ");
    cprintf("\n\n");
    center("   If you do not fully understand the functions of these");
    cprintf("\n");
    center("bits please refer to the DS0607 Developers Kit.         ");
    cprintf("\n");
    gotoxy(1, 23);
    center("PRESS ANY KEY TO CONTINUE");
    getch();
}

Byte i, j;                                                   /* Loop counter */
Byte alarmf;
unsigned long l;
Byte PartCount = 0;                            /* Number of DOW parts on bus */
Byte Not_1994 = 1;
Byte AuthCode[3], PageData[32];
Byte PageNo;                            /* Current secure memory page number */
Byte tick;

Byte Read_S_Mem(Byte PageNo, Byte PageData[32])
{
    if (Access())      /* Begin communication with currently selected DS1994 */
    {
        tick = 1;
        Databyte(0xF0);                   /* Send read secure memory command */
        Databyte((0x20 * PageNo) & 0xFF); /* Send low byte of target address */
        Databyte(((0x20 * PageNo) & 0x0300) >> 8);   /* Send high byte of TA */
        for (i = 0; i < 32; i++) PageData[i] = Databyte(0xFF);  /* Read data */
        return 1;
    }
    tick = 0;
    return 0;
    
}

Byte WriteScratch(Byte PageNo, Byte PageData[32])
{
    if (Access())      /* Begin communication with currently selected DS1994 */
    {
        Databyte(0x0F);                     /* Send write scratchpad command */
        Databyte((0x20 * PageNo) & 0xFF); /* Send low byte of target address */
        Databyte(((0x20 * PageNo) & 0x0300) >> 8);    /* Send low byte of TA */
        for (i = 0; i < 32; i++) Databyte(PageData[i]);  /* Write scratchpad */
        return 1;
    }
    return 0;
}

Byte ReadScratch(Byte PageData[32])
{
    if (Access())      /* Begin communication with currently selected DS1994 */
    {
        Databyte(0xAA);                  /* Send the read scratchpad command */
        for (i = 0; i < 3; i++) AuthCode[i] = Databyte(0xFF);/* Read the auth*/
        for (i = 0; i < 32; i++) PageData[i] = Databyte(0xFF); /* code bytes */
        return 1;
    }
    return 0;
}

CopyScratch(Byte AuthCode[3])
{
    if (Access())      /* Begin communication with currently selected DS1994 */
    {
        Databyte(0x55);                  /* Send the copy scratchpad command */
        for (i = 0; i < 3; i++) Databyte(AuthCode[i]);     /* Send auth code */
        return 1;
    }
    return 0;
}

/* NOTE:                                                                     */
/*	 Tbis function is an adaption of the function referred to as DS14x7().   */
/* It provides an example in showing how easy it is to maintain compatibility*/
/* with older part, if this is desired.                                      */
Byte DS1994Compatible(void)
{
    Byte far *addr;
    Byte far *far pascal Romdata();
    
    addr = Romdata();
    if ((*addr == 0x84) || (*addr == 0x04))
    {
        printf("found family code:%X\n",addr[0]);
        return 1;
    }
    else /* If the first byte of the ROM data is not an 0x84 or 0x04 */
    {
        printf("found family code:%X\n",addr[0]);
        return 0;    /* the part is not DS1994-compatible */
    }
}

Byte findno, Currno;

void CloseIt(void)
{
    window(1, 1, 80, 25);
    clrscr();
    printf("\nAt least one DS1994-compatible device must be connected\n");
    keyclose();
    exit(1);
}

void findall(void)
{
    findno = 0;
    if (First())                    /* Select the first part on the LPT port */
    {
        if (DS1994Compatible())
            ++findno;
        while (Next())
            if (DS1994Compatible())
                ++findno;                          /* Look for more DS1994's */
    }
}

void getlast(void)
{
    Byte fail = 0;

    findall();             /* Find out how many DS1994's are on the LPT port */

    while (Next());                          /* Point back to first DOW part */
    if (Currno == 1)
        Currno = findno;
    else
        --Currno;
    for (i = 0; i < Currno; i++)
        Next();                                 /* Point to the previous D0W */
    if (DS1994Compatible())
        return;                       /* Return if this DOW part is a DS1994 */
    while (!fail)  /* If previous part no longer there, then find first part */
    {
        if (First())         /* Find first DOW part on the selected LPT port */
        {
            if (DS1994Compatible()) /* Find out if this DOW part is a DS1994 */
            {
                if (Currno == 1) Currno = findno; else --Currno;
                return;
            }
            while (Next()) if (DS1994Compatible())
                                      /* First DOW part was not a DS1994, so */
            {                         /* call next until we find a DS1994,   */
                                      /* or NEXT fails                       */
                if (Currno == 1)
                    Currno = findno;
                else
                    --Currno;
                return;
            }
        }
        fail = 1;
    }
    CloseIt();                                /* Could not find any DS1994's */
                                              /* (or compatible parts)       */
}

void getnext(void)
{
    Byte fail = 0, onepass = 0, tr;

    while (!fail)
    {
        tr = Next();            /* Select next DOW part on selected LPT port */
        if (tr && DS1994Compatible())
        {
            if (onepass)
                Currno = 1;
            else
                ++Currno;                        /* Next part has been found */
            return;
        }
        if (tr == 0)
            ++onepass;         /* If next failed go back to the 1st DOW part */
        if (!tr && (onepass == 2))
            fail = 1;
    }
    CloseIt();                               /* Could not find any DS1994's */

}

void printsn(void)
{
    Byte far *addr;
    Byte far *far pascal Romdata();

    window(1, 1, 80, 2); clrscr();
    addr = Romdata() + 1;
    gotoxy(22, 1);
    cprintf("SERIAL NUMBER: [ ");
    for (i = 0; i < 6; i++) cprintf("%2.2X ", *addr++);
    cprintf("]");
}


Byte x[5] = { 38, 9, 9, 9, 9 };
Byte y[5] = { 4, 6, 8, 13, 20 };

void printit(Byte fn)
{
    gotoxy(1, 10); center("SCRATCH PAGE");
    gotoxy(1, 11); center("");
    if (fn == 4)
    {
        gotoxy(30, 17); cprintf("SECURE MEMORY PAGE # %02d", PageNo);
        gotoxy(30, 18); cprintf("");
    }
    if (fn > 2)
    {
        gotoxy(x[fn], y[fn]);
        for (i = 0; i < 16; i++) cprintf("%2.2X ", PageData[i]);
        gotoxy(x[fn] + 49, y[fn]);
        for (i = 0; i < 16; i++)
        {
            if ((PageData[i] < 0x80) && (PageData[i] > 0x19))
                cprintf("%c", PageData[i]); else cputs(".");
        }
        gotoxy(x[fn], y[fn] + 1);
        for (i = 16; i < 32; i++) cprintf("%2.2X ", PageData[i]);
        gotoxy(x[fn] + 49, y[fn] + 1);
        for (i = 16; i < 32; i++)
        {
            if ((PageData[i] < 0x80) && (PageData[i] > 0x19))
                cprintf("%c", PageData[i]); else cputs(".");
        }
    }
}

void dispdata(void)                    /* Display data in part number PartNo */
{
    Byte far *addr;
    Byte far *far pascal Romdata();

    addr = Romdata() + 1;
    gotoxy(22, 2);
    cprintf("SERIAL NUMBER: [ ");
    for (i = 0; i < 6; i++) cprintf("%2.2X ", *addr++);
    cprintf("]");
    gotoxy(11, 4);
    cprintf("REAL TIME CLOCK:");
    ReadScratch(PageData);
    printit(3);
    Read_S_Mem(PageNo, PageData);
    printit(4);
}

Word dm[13] = { 0, 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334 };
Byte bv;
Word iv, jv, sv;
DWord yv, xv;

long dtu(struct mdate *dat, struct mtime *tim)
{
    sv = dat->da_year - 1968;
    if ((dat->da_mon > 2) && !(sv & 3))
        bv = 1;
    else
        bv = 0;

    q = div(sv - 1, 4);
    xv = 365 * (sv - 2) + q.quot + dm[dat->da_mon] +
        dat->da_day + bv - 1;
    xv = 86400 * xv + tim->ti_sec + 60 *
        ((DWord) tim->ti_min + 60 * (DWord) tim->ti_hour);
    return xv;
}

void utd(long l, struct mdate *dat, struct mtime *tim)
{
    if (l & 0x80000000) return;
    ql = ldiv(l, 86400); xv = ql.quot;
    yv = l - 86400 * xv;
    xv = 4 * (xv + 731); ql = ldiv(xv, 1461);
    dat->da_year = ql.quot;
    ql = ldiv(xv - 1461 * dat->da_year, 4);
    iv = ql.quot; dat->da_mon = 13;
    do
    {
        if ((--dat->da_mon > 2) && !(dat->da_year & 3)) bv = 1; else bv = 0;
        jv = dm[dat->da_mon] + bv;
    }
    while (iv < jv);
    dat->da_day = iv - jv + 1;
    dat->da_year += 1968;
    ql = ldiv(yv, 3600); tim->ti_hour = ql.quot;
    ql = ldiv(yv - (DWord) tim->ti_hour * 3600, 60); tim->ti_min = ql.quot;
    tim->ti_sec = yv - (DWord) tim->ti_min * 60 - (DWord) tim->ti_hour * 3600;
}

unsigned long ltemp[4], savef[4];

void formatticks(void)
{
    l = 0;
    for (i = 0; i < 4; i++)
        l = l + (ltemp[i] << (i << 3));
    utd(l, &dat, &tim);
}

void getticks(void)
{
    Read_S_Mem(16, PageData);
    alarmf = PageData[0] & 7;
    for (i = 0; i < 4; i++)
        ltemp[i] = PageData[3 + i];
    formatticks();
}

const unsigned long decsec = 0;

void update(void)
{
    getticks();
    gotoxy(x[0], y[0]);
    if (!(l & 0x80000000))
    {
        cprintf("%02d:%02d:%02d", tim.ti_hour, tim.ti_min, tim.ti_sec);
        gotoxy(x[0] + 25, y[0]);
        cprintf("%02d/%02d/%04d", dat.da_mon, dat.da_day, dat.da_year);
    }
    else
    {
        cprintf("00:00:00");
        gotoxy(x[0] + 25, y[0]);
        cprintf("00/00/0000");
    }
    if (PageNo == 16) printit(4);
    if (alarmf & 1)
    {
        gotoxy(1, y[0] + 2);
        center("A REAL TIME CLOCK ALARM HAS OCCURED");
    }
    if (alarmf & 2)
    {
        gotoxy(1, y[0] + 3);
        center("AN ELAPSE TIMER ALARM HAS OCCURED");
    }
    if (alarmf & 4)
    {
        gotoxy(1, y[0] + 4);
        center("A CYCLE COUNTER ALARM HAS OCCURED");
    }
    if (tick && ((PageData[1] >> 4) & 1))  /* Tick if part there and osc = 1 */
    {
        sound(5000); delay(1); nosound();                            /* tick */
    }
}

void printfld(void)
{
    if (!(l & 0x80000000))
    {
        cprintf("%02d:%02d:%02d     %02d/%02d/%04d", tim.ti_hour, tim.ti_min,
            tim.ti_sec, dat.da_mon, dat.da_day, dat.da_year);
    }
    else cprintf("00:00:00     00/00/0000");
}

void printclk(void)
{
    printsn();
    combar();
    center("LARR, RARR => EDITING        F1 => LEGEND           ESC => QUIT");
    textwin();
    clrscr();
    gotoxy(15, 2); cprintf("      REAL TIME CLOCK:");
    gotoxy(15, 4); cprintf("REAL TIME CLOCK ALARM:");
    gotoxy(15, 6); cprintf("         ELAPSE TIMER:");
    gotoxy(15, 8); cprintf("   ELAPSE TIMER ALARM:");
    gotoxy(15, 10); cprintf("        CYCLE COUNTER:");
    gotoxy(15, 12); cprintf("  CYCLE COUNTER ALARM:");
    gotoxy(1, 13);
    for (i = 0; i < 80; i++) cputs("");
    gotoxy(1, 14); center("CONFIGURATION/STATUS REGISTERS  (200H AND 201H)");
    gotoxy(6, 16);
    cputs("DON'T CARE            READ ONLY");
    gotoxy(6, 17);
    cputs("                         ");
    gotoxy(6, 18);
    cputs(" Ŀ    Ŀ    STRT AUTO");
    gotoxy(6, 19);
    cputs(" XXX XXX CCE ETE RTE CCF ETF RTF DSL STP MAN OSC RO  WPC WPE WPR");
    gotoxy(7, 20);
    for (i = 0; i < 63; i++) cputs("");
    gotoxy(7, 21);
    for (j = 0; j < 2; j++) for (i = 8; i > 0; i--)
        if ((PageData[j] >> (i - 1)) & 1)
            cputs("ON  ");
        else
            cputs("OFF ");
        for (i = 0; i < 4; i++)
            ltemp[i] = PageData[i + 3];
        formatticks();
        if (l >= decsec)
            savef[0] = l;
        gotoxy(40, 2); printfld();
        for (i = 0; i < 4; i++)
            ltemp[i] = PageData[i + 17];
        formatticks();
        if (l >= decsec)
            savef[1] = l;
        gotoxy(40, 4); printfld();
        for (i = 0; i < 4; i++)
            ltemp[i] = PageData[i + 8];
        formatticks();
        if (l >= decsec)
            savef[2] = l;
        gotoxy(40, 6); printfld();
        for (i = 0; i < 4; i++)
            ltemp[i] = PageData[i + 22];
        formatticks();
        if (l >= decsec)
            savef[3] = l;
        gotoxy(40, 8); printfld();
        for (i = 0; i < 4; i++)
            ltemp[i] = PageData[i + 12];
        l = 0;
        for (i = 0; i < 4; i++)
            l = l + (ltemp[i] << (i << 3));
        gotoxy(40, 10); cprintf("%ld", l);
        for (i = 0; i < 4; i++)
            ltemp[i] = PageData[i + 26];
        l = 0;
        for (i = 0; i < 4; i++)
            l = l + (ltemp[i] << (i << 3));
        gotoxy(40, 12); cprintf("%ld", l);
}

Byte nsc, plc;
Byte ofst[10] = { 3, 3, 17, 17, 8, 8, 22, 22, 12, 26 };
Byte max[10] = { 6, 8, 6, 8, 6, 8, 6, 8, 10, 10 };
Byte xc[26] = { 40, 53, 40, 53, 40, 53, 40, 53, 40, 40,  7, 11, 15,
19, 23, 27, 31, 35, 39, 43, 47, 51, 55, 59, 63, 67 };

Byte yc[26] = { 2, 2, 4, 4, 6, 6, 8, 8, 10, 12, 21, 21, 21, 21,
21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21 };

void gethexbytes(Byte pos)        /* Convert a long int. into four hex bytes */
{
    for (i = 0; i < 4; i++)
    {
        PageData[i + ofst[pos]] = l & 0xFF;
        l = l >> 8;
    }
}

void ClockPage(void)
{
  Byte dbuff[10];               /* Temporary data storage for keyboard input */
  Byte ks, pos = 0;                    /* keystroke, screen position pointer */
  Byte cvar[5], fbit = 1, skip, cchar;
  Word yword;
  unsigned long tstore[5];    /* Temporary long var storage for calculations */
  Read_S_Mem(16, PageData);                       /* Read data in clock page */
  printclk();                         /* Send results of data read to screen */
  gotoxy(xc[pos], yc[pos]);                    /* Initialize cursor position */
  plc = 0;
  while (1)
  {
    nsc = 0;
    skip = 0;
    ks = getch();
    switch (ks)
    {
    case 0:                                          /* Alt - ? has been hit */
      nsc = 1;
      ks = getch();
      switch (ks)
      {
      case 77:                                /* Right arrow key has pressed */
        if (!plc)
        {
          if (pos == 14) pos = pos + 4;
          else
          {
            if (pos == 25) pos = 0; else pos++;
          }
          gotoxy(xc[pos], yc[pos]);
        }
        break;
      case 75:                                     /* Left arrow key pressed */
        if (!plc)
        {
          if (pos == 18) pos = pos - 4;
          else
          {
            if (pos == 0) pos = 25; else pos--;
          }
          gotoxy(xc[pos], yc[pos]);
        }
        break;
      case 72:
        getnext();
        Read_S_Mem(16, PageData);
        printclk();
        pos = 0; plc = 0;
        gotoxy(xc[pos], yc[pos]);
        break;
      case 80:
        getlast();
        Read_S_Mem(16, PageData);
        printclk();
        pos = 0; plc = 0;
        gotoxy(xc[pos], yc[pos]);
        break;
      case 59:                                             /* F1 key pressed */
        help();                                           /* Show key legend */
        printclk();                               /* Display clock page data */
        pos = 0;
        gotoxy(xc[pos], yc[pos]);                   /* Reset cursor position */
        break;
      case 20:
        WriteScratch(16, PageData);
        ReadScratch(PageData);
        for (j = 0; j < 3; j++)
        {
          CopyScratch(AuthCode);
          AuthCode[2] = AuthCode[2] | 0x80;
        }
        return;
      }
      break;
      case 27:
        window(1, 1, 80, 24);
        clrscr();
        keyclose();                        /* release control between passes */
        exit(0);
        break;
      case 13:
        nsc = 1;
        if (pos >= 10)
        {
          if (pos < 18)
          {
            PageData[0] = PageData[0] ^ (fbit << (17 - pos));   /* comp. bit */
            if ((PageData[0] >> (17 - pos)) & 1)
                cputs("ON ");
            else
                cputs("OFF");
            pos++;
            if (pos == 15) pos = pos + 3;
            gotoxy(xc[pos], yc[pos]);
          }
          else
          {
            PageData[1] = PageData[1] ^ (fbit << (25 - pos));   /* comp. bit */
            if ((PageData[1] >> (25 - pos)) & 1)
                cputs("ON ");
            else
                cputs("OFF");
            if ((pos > 22) && ((PageData[1] >> (25 - pos)) & 1))
            {
              warning();
              clrscr();
              gotoxy(12, 1); center("ARE YOU SURE ???");
              do
              {
                cchar = toupper(getch());
              }
              while ((cchar != 0x4e) && (cchar != 0x59));
              if (cchar == 0x4e)
              {
                PageData[1] = PageData[1] ^
                        (fbit << (25 - pos));                   /* comp. bit */
                if ((PageData[1] >> (25 - pos)) & 1)
                    cputs("ON ");
                else
                    cputs("OFF");
              }
              printclk();
            }
            if (pos == 25) pos = 0; else pos++;
            gotoxy(xc[pos], yc[pos]);
          }
        }
        else                             /* We're in one of the clock fields */
        {
          if (!(pos & 1) && (pos != 8) && (plc == max[pos]))
          {
            for (i = 0; i < 3; i++) cvar[i] = dbuff[2*i]*10 + dbuff[2*i+1];
            if ((cvar[0] < 24) && (cvar[1] < 60) && (cvar[2] < 60))
            {
              if (savef[pos >> 1] > decsec) utd(savef[pos >> 1], &dat, &tim);
              tim.ti_hour = cvar[0];             /* Enter new time structure */
              tim.ti_min = cvar[1];
              tim.ti_sec = cvar[2];
              l = dtu(&dat, &tim);
              savef[pos >> 1] = l;
              gethexbytes(pos);
              plc = 0; pos++; gotoxy(xc[pos], yc[pos]);      /* Set new pos. */
            }
            else
            {
              plc = 0; gotoxy(xc[pos], yc[pos]);
            }
          }
          else if ((pos & 1) && (pos != 9) && (plc == max[pos]))
          {
            for (i = 0; i < 2; i++) cvar[i] = dbuff[2*i]*10 + dbuff[2*i+1];
            yword = dbuff[4]*1000 + dbuff[5]*100 + dbuff[6]*10 + dbuff[7];
            if ((cvar[0] < 13) && (cvar[1] < 32) && (yword > 1969))
            {
              dat.da_year = yword;
              dat.da_mon = cvar[0];
              dat.da_day = cvar[1];



              l = dtu(&dat, &tim);
              savef[(pos - 1) >> 1] = l;
              gethexbytes(pos);
              plc = 0; pos++; gotoxy(xc[pos], yc[pos]);      /* Set new pos. */
              if (pos == 8) skip = 1; else skip = 0;
            }
            else
            {
              plc = 0; gotoxy(xc[pos], yc[pos]);
            }
          }
          else if (!skip && (pos >= 8))
          {
            l = 0;
            for (i = 0; i < plc; i++)
            {
              tstore[0] = dbuff[i];
              l = l + tstore[0] * pow(10, plc - i - 1);
            }
            gethexbytes(pos);
            plc = 0; pos++; gotoxy(xc[pos], yc[pos]);
          }
        }
        break;
      case 8:
        nsc = 1;
        if (plc && (pos < 10))
        {
          if (pos < 8) if ((plc == 2) || (plc == 4))
            gotoxy(wherex() - 1, wherey());
          cprintf("%c %c", ks, ks);
          dbuff[--plc] = 0;
        }
        break;
    }
    if (!nsc && (pos < 10))
    {
      if (!plc)
      {
        if (max[pos] == 10) cputs("              ");
        if (max[pos] == 6) cputs("  :  :  ");
        if (max[pos] == 8) cputs("  /  /    ");
        gotoxy(xc[pos], yc[pos]);
      }
      if ((ks > 47) && (ks < 58))
      {
        if (plc != max[pos])
        {
          dbuff[plc++] = ks - 48;
          cprintf("%c", ks);
          if (pos < 8) if ((plc == 2) || (plc == 4))
            gotoxy(wherex() + 1, wherey());
        }
      }
    }
  }
}

void main(void)
{
  Byte ch;                               /* Character received from keyboard */
  Byte doit, TempSec, Curr_Num;
  Byte PartNo;                                 /* Number of current DOW part */
  Byte charr[32];
  Byte xp, yp;                              /* Save location of cursor bytes */
  Byte pfound;

  window(1, 1, 80, 25); clrscr();                          /* Initialize crt */
  sound(0); delay(0); nosound();                                /* Fake beep */
  l = 0;                                                 /* Default LPT port */

  pfound = False;
  dowcheck();
  while (!pfound && l++ < 4)                   /* Search ports for DOW parts */
  {
    if (Setup(l))                             /* Check for existance of port */
    {
      if (keyopen())
      {
        if (Gndtest())               /* If printer is attached is it on line */
        {
          if (First())                 /* See if a DS142x is on LPT port #pn */
            pfound = True;             /* At least 1 part is on LPT port #pn */
        }
      }
      keyclose();                          /* release control between passes */
    }
  }

  if (!pfound)
  {
    printf("Unable to find any buttons on any port\n");
    exit(1);
  }

  keyopen();                                          /* get control of port */

  while (Next());                                  /* Point to the beginning */
  getnext();
  Currno = 1;
  PageNo = 0;
  initcrt();
  getticks();                     /* Read time from DS1994's real time clock */
  dispdata();
  gettime(&tim);
  TempSec = tim.ti_sec;
  doit = 1;                                    /* Update Time info in DS1994 */
  gotoxy(58, 13);                              /* Initialize cursor position */
  ++PartCount;
  plc = 0;
  if (PartCount)
  {
    while (1)
    {
      keyclose();                  /* release control of port between passes */
      keyopen();                                   /* regain control of port */
      if (kbhit())
      {
        nsc = 0;
        ch = getch();
        switch(ch)
        {
        case 0:                 /* Alt - <?> has been received from keyboard */
          nsc = 1;
          ch = getch();                        /* Get specific Alt character */
          switch(ch)
          {
          case 81:                                  /* Page down key pressed */
            if (PageNo == 0) PageNo = 16; else --PageNo;
            xp = wherex(); yp = wherey();            /* Save cursor position */
            Read_S_Mem(PageNo, PageData);                   /* Read new page */
            printit(4);                                    /* Print new page */
            gotoxy(xp, yp);                       /* Restore cursor position */
            break;
          case 73:                                    /* Page up key pressed */
            if (PageNo == 16) PageNo = 0; else ++PageNo;
            xp = wherex(); yp = wherey();     /* Save current loc. on screen */
            Read_S_Mem(PageNo, PageData);     /* Read new secure memory page */
            printit(4);
            gotoxy(xp, yp);              /* Restore previous cursor position */
            break;
          case 72:
            getnext();            /* Go find the next DS1994 on the LPT port */
            initcrt();                              /* Initialize the screen */
            getticks();           /* Read time from DS1994's real time clock */
            dispdata();         /* Print out scratch data and sec. mem, time */
            gettime(&tim);                                   /* Get DOS time */
            TempSec = tim.ti_sec;                     /* Save current second */
            doit = 1;           /* doit = 1 => Read DS1994 and print it time */
            gotoxy(58, 13);                    /* Initialize cursor position */
            break;
          case 80:
            getlast();       /* Go back to the previous part on the LPT port */
            initcrt();                                 /* Initialize display */
            getticks();           /* Read time from DS1994's real time clock */
            dispdata();                 /* Display data read from the DS1994 */
            gettime(&tim);                                   /* Get DOS time */
            TempSec = tim.ti_sec;                     /* Save current second */
            doit = 1;                          /* Update Time info in DS1994 */
            gotoxy(58, 13);                    /* Initialize cursor position */
            break;
          case 59:
            help();                                      /* Print the legend */
            initcrt();                               /* Reformat the display */
            dispdata();                               /* Display DS1994 data */
            plc = 0;                             /* Initialize array pointer */
            gotoxy(58, 13);                    /* Initialize cursor position */
            break;
          case 20:
            ClockPage();                        /* Switch display/edit modes */
            PageNo = 16;                   /* Point to secure memory page #0 */
            initcrt();                           /* Return to memory display */
            dispdata();                 /* Display data read from the DS1994 */
            plc = 0;                 /* Initialize memory page array pointer */
            gotoxy(58, 13);                    /* Initialize cursor position */
            break;
          }
          break;
          case 13:                   /* Return key hit, write data to DS1994 */
            nsc = 1;                      /* Indicate this is not data entry */
            if ((PageNo != 16) && plc)
            {
              for (i = 0; i < 32; i++)
                PageData[i] = charr[i];                        /* copy array */
              WriteScratch(PageNo, PageData);     /* Send data to scratchpad */
              ReadScratch(PageData);  /* Read back scratchpad to get auth-   */
              CopyScratch(AuthCode);  /* orization bytes, the copy to smem.  */
              Read_S_Mem(PageNo, PageData);     /* Read new smem from DS1994 */
              printit(3);                         /* Display scratchpad data */
              printit(4);                      /* Display secure memory data */
              plc = 0;                                /* Reset place counter */
              gotoxy(58, 13);          /* Reset cursor to beginning of field */
            }
            break;
          case 8:                          /* Backspace key has been pressed */
            nsc = 1;     /* Indicate this is not intended as scratchpad data */
            if (plc)                               /* Don't backspace to far */
            {
              charr[--plc] = 32;
              if (plc == 15) gotoxy(74, 13);
              cprintf("%c %c", ch, ch);
            }
            break;
          case 27:                            /* Escape key has been pressed */
            window(1, 1, 80, 25);                     /* Restore screen size */
            clrscr();
            keyclose();               /* release control of port before exit */
            exit(0);
            break;
        }
        if (!nsc)                    /* Was last keystroke intended as data? */
        {
          if (!plc)                      /* First character in scratch page? */
          {
            for (i = 0; i < 32; i++)     /* If so clear out old scratch data */
            {
              charr[i] = 32;
              if (i == 16) gotoxy(58, 14);
              cprintf(" ");
            }
            gotoxy(58, 13);
          }
          if (plc != 32)                    /* Otherwise store data in array */
          {
            cprintf("%c", ch);
            charr[plc] = ch;
            if (++plc == 16) gotoxy(58, 14);
          }
        }
         }
         if (doit)          /* doit = 1 => update current date and time info */
         {
           xp = wherex(); yp = wherey();
           update();
           gotoxy(xp, yp);
           doit = 0;
         }
         else
         {
           gettime(&tim);
           if (tim.ti_sec != TempSec)         /* Has one second passed yet ? */
           {
             doit = 1;  /* If so set flag indicating its time to read DS1994 */
             TempSec = tim.ti_sec;
           }
         }
      }
   }
   else printf("At least one DS1994-compatible device must be connected\n");
   keyclose();                                   /* release port before exit */
}
