;******************************************************************************
;*                                                                            *
;*  SauthAsm.asm                                                              *
;*  DS Software Authorization SDK 4.31                                        *
;*  Disk 1 - Dos Object & Source Files                                        *
;*  07/09/98                                                                  *
;*                                                                            *
;*  Copyright (C) 1994, 1996,1997, 1998 Dallas Semiconductor Corporation.     *
;*  All rights Reserved. Printed in U.S.A.                                    *
;*  This software is protected by copyright laws of                           *
;*  the United States and of foreign countries.                               *
;*  This material may also be protected by patent laws of the United States   *
;*  and of foreign countries.                                                 *
;*  This software is furnished under a license agreement and/or a             *
;*  nondisclosure agreement and may only be used or copied in accordance      *
;*  with the terms of those agreements.                                       *
;*  The mere transfer of this software does not imply any licenses            *
;*  of trade secrets, proprietary technology, copyrights, patents,            *
;*  trademarks, maskwork rights, or any other form of intellectual            *
;*  property whatsoever. Dallas Semiconductor retains all ownership rights.   *
;*                                                                            *
;*  Additional Notes:                                                         *
;*                                                                            *
;*     This module was assembled using version 6.11 MASM.  Other assemblers   *
;*     may require some modification of the source code, depending on the     *
;*     implementation.                                                        *
;*                                                                            *
;******************************************************************************
;
;               ver 2.00 -> added ds1410e support
;               ver 2.01 -> Fixed printer grounding pin 14 <out portadr, ECh>

public      SETUP, FIRST, NEXT, ROMDATA, ACCESS, DATABYTE, GNDTEST 
public      KEYOPEN, KEYCLOSE, DOWCHECK, OVERDRIVEOFF, OVERDRIVEON
public      CHECKOD, TOGGLEOVERDRIVE,DOWRESET
;
code        segment       para '_TEXT'
            assume        cs:code
;
offs        equ           offset            ; Make short ver of offset for columns. 
bptr        equ           byte ptr          ; Make short ver of byte ptr.   
wptr        equ           word ptr          ; Make short ver of word ptr.
;
portadr     equ           cs:0[di]          ; Parallel port address. 
count       equ           cs:2[di]          ; Number of times to loop for 64us.
ec          equ           cs:5[di]          ; Used for decrement loop in rom srch.
ld          equ           cs:6[di]          ; Position of last disagreement.
lc          equ           cs:7[di]          ; Loop counter.
fb          equ           cs:8[di]          ; Flag byte to control next.
l0          equ           cs:9[di]          ; Pointer for rom search algorithm.
setupok     equ           cs:10[di]         ; 0 => setup failed, 1 => success.
accok       equ           cs:11[di]         ; 0 => access failed, 1 => success.
romdta      equ           cs:20[di]         ; Eight byte rom data buffer.
bpap2       equ           cs:29[di]         ; Base port address plus 2.
Count4      equ           cs:30[di]         ; count to burn 4 us
DRegByte    equ           cs:32[di]         ; byte sent to do_comm
;
glocate     proc          near              ; Get offset of globals in di.
            call          gloc              ; Get offset of global space on stack. 
            dw            0                 ; Parallel port address. 
            dw            0                 ; Number of times to loop for 64us.
            db            0                 ; Port number.
            db            0                 ; Used for decrement loop in rom srch.
            db            0                 ; Position of last disagreement.
            db            0                 ; Loop counter. 
            db            0                 ; Flag byte to control next.
            db            0                 ; Pointer for rom search algorithm.
            db            0                 ; 0 => setup failed, 1 => success.
            db            0                 ; 0 => access failed, 1 => success.
            dw            0                 ; CRC16 accumulator.
            db            0                 ; 0 => not DOS2xy, 1 => DOS2xy.
            dw            0                 ; Offset of vpxd.386 entry point.
            dw            0                 ; Segment of vpxd.386 entry point.
            db            0                 ; 0 => protected port,1 => unprotected.
            db            8 dup (0)         ; Eight byte rom data buffer.
            db            0                 ; Printer port character. 
            db            0                 ; Base port address plus 2. 
            dw            ?
            db            ?                 ; byte sent to do_comm
gloc:
            pop           di                ; Offset of global var space is in di.
            ret                             ; Return to caller.
glocate     endp                            ; End of glocate procedure.
;
cpmess:     db        'COPYRIGHT (C) 1997 DALLAS SEMICONDUCTOR'
;==============================================================================
; Keyopen - takes the ds1481 out of passthru.  
;==============================================================================
KEYOPEN     proc          far
            push          di                ; save callers di register
            call          glocate           ; point to our global variables
            call          exitpt            ; do the exit passthru
            mov           dx, portadr       ; dx get portaddress for do_comm
            mov           al, 0FFh          ; do a write 1
            call          do_comm           
            mov           ax,      1        ; success
            pop           di                ; restore callers register
            ret                             ; Return to caller.
KEYOPEN  endp
;==============================================================================
; Keyclose - put the 1481 in passthru mode
;==============================================================================
KEYCLOSE    proc          far
            push          di                ; save callers registers
            call          glocate
            call          TogglePT          ; Enter passthru mode.
            mov           ax,      1        ; Just return TRUE result.
            mov           cx,      ax
            pop           di
            ret                             ; Return to caller.
KEYCLOSE endp
;==============================================================================
; Dowcheck - returns true in dos
;==============================================================================
DOWCHECK    proc          far
            mov           ax,      1        ; Just return TRUE result.
            ret                             ; Return to caller.
DOWCHECK endp
;==============================================================================
; OverdriveOff - turn overdrive off in 1481
;==============================================================================
OVERDRIVEOFF proc         far
            push          di                ; save callers register
            call          glocate           ; point to global variables
            call          ExitOD            ; do the exit overdrive
            mov           ax,      1        ; happy result
            pop           di                ; restore callers register
            ret
OVERDRIVEOFF endp
;==============================================================================
; OverdriveOn - turn overdrive on for 1481
;==============================================================================
OVERDRIVEON proc          far
            push          di                ; save callers registers
            call          glocate           ; point to global variables
            call          touchreset        ; do a reset on the part
            mov           ax,        03Ch   ; put parts in overdrive
            call          touchbyte         ; send the byte to the part
            call          ToggleOD          ; toggle parts
            cmp           ax,        1      ; see if it worked
            je            ovd_2             ; toggle it->leave success
            call          ToggleOD          ; toggle it again
            cmp           ax,        1      ; see if it worked
            je            ovd_2

ovd_1:
            mov           al,        0      ; set failure condition
            jmp           ovd_3
ovd_2:                  
            mov           al,        1      ; set success condition
ovd_3:                  
            pop           di
            ret
OVERDRIVEON endp
;==============================================================================
;   This procedure finds the first DOW part on the bus. 
;==============================================================================
FIRST       proc          far               ; Procedure to find first part on bus.
            push          di                ; Save callers di register.
            call          glocate           ; Get offset to global vars in di.
            mov bptr      l0,      65       ; Point Rom Search algorithm to top.
            mov bptr      fb,      0        ; Try to find a DOW part first.
            push          cs                ; Get ready for far call.
            call near ptr NEXT              ; Go find first part.
            pop           di                ; Restore di register.
            ret                             ; Return to caller.
FIRST       endp                            ; End of first procedure.
;==============================================================================
; Next - Finds the Next part on the bus, except when called by first 
;==============================================================================
NEXT        proc          far               ; Procedure to find next part on bus.
            push          di                ; Save di register.
            push          bx                ; Save bx register.
            call          glocate           ; Get offset of globals in di.
            cmp bptr      setupok,1         ; Did last call to setup succeed.
            jne           bjlf              ; Leave if it did not. 
toplab:
            cmp bptr      fb,     1         ; Have we found all parts on bus yet.
            jne           dosearch          ; Jump if more parts to be found. 
            mov bptr      fb,     0         ; Clear forced failure flag.
            mov bptr      l0,     65        ; Point rom search alg. to 1st part.
            xor           ax,     ax        ; Set failure condition.
bjlf:
            jmp           levf              ; Leave procedure. 
dosearch:
            call          romsrch           ; Find next part on bus.
            cmp           al,     1         ; Did we find a DOW part. 
            je            filter            ; Leave if successful.
            cmp           al,     2         ; Did we find the last DOW part.
            jne           levf              ; Leave with failure condition set.
            mov bptr      fb,     1         ; Set forced failure byte. 
            jmp           filter            ; Leave successful.
filter:
            mov           al,     romdta    ; Get family code in al.
            cmp           al,     0         ; See if bus shorted.
            je            levf              ; Abort if it was. 
            mov           ax,     1         ; Indicate a valid part found.
            jmp           skipfilt          ; Skip over rest of filter.
notcustom:
            cmp           al,     2         ; See if this is an old valid DS1205. 
            jne           zerorom?          ; Jump if it is. 
grandpart:
            mov           al,     romdta[2] ; Get third byte of ROM data in al.
            cmp           al,     16H       ; See if 3rd byte to big.
            ja            zerorom?          ; If number to big abort.
            mov           bx,     3         ; First byte of ROM data to check.
lookbyte:
            mov           al,     romdta[bx]; Get byte of ROM data in al.
            cmp           al,     0         ; See if byte = 0.
            jnz           zerorom?          ; If byte non-zero part is invalid.
            inc           bx                ; Index to next byte of ROM data.
            cmp           bx,     6         ; Have we checked all 4 bytes yet.
            jbe           lookbyte          ; Keep going until all bytes checked.
            mov           ax,     1         ; Indicate part is valid.
            jmp           skipfilt          ; Skip setting failure condition.
zerorom?:
            cmp bptr      fb,     1         ; Was this the last DOW part on bus.
            jne           toplab            ; If not look at next part.
            xor           bx,     bx        ; Starting index into romdta.
            xor           al,     al        ; Value to move into ROM data buffer.
zerobyte:
            mov           romdta[bx], al    ; Clear byte of romdta buffer.
            inc           bx                ; Point to next byte in buffer.
            cmp           bx,     8         ; All bytes cleared yet?
            jb            zerobyte          ; Continue if not.
levf:
            xor           ax,     ax        ; Set failure condition. 
skipfilt:
            pop           bx                ; Restore bx register.
            pop           di                ; Restore di register. 
            ret                             ; Return to caller.
NEXT    endp                                ; End of next procedure.
;==============================================================================
; Romsrch - finds the romid of part on bus
;==============================================================================
romsrch     proc          near              ; Rom search procedure.
            push          bx                ; Save bx register.
            push          cx                ; Save cx register.
            mov           al,     l0        ; Get rom search pointer in al.
            mov           ld,     al        ; Save last disagreement position
            call          touchreset        ; Issue reset pulse.
            cmp           al,     1         ; Was a presence detected.
            jne           bjump             ; Abort if no presence detected.
            mov           ax,     0F0H      ; Rom search command.
            call          touchbyte         ; Send command to LPT #pn.
            mov bptr      lc,     64        ; 64 bits of Rom Data.
            mov bptr      ec,     8         ; Initialize eight counter.
            xor           bx,     bx        ; Clear bx to use for indexing.
            jmp           romloop           ; Time to read the bits.
bjump:
            jmp           fail              ; Make big jump to fail.
romloop:
            mov           ax,     1         ; Prepare to send read time slot. 
            call          touchbit          ; Read a bit from part(s) on LPT #pn.
            mov           cl,     al        ; Get result in bl.
            shl           cl,     1         ; Make room for next read bit. 
            push          cx                ; Save last result.
            mov           ax,     1         ; Call tbit to send a read time slot.
            call          touchbit          ; Read a bit from part(s) on LPT #pn.
            pop           cx                ; Get result from 1st read time slot.
            or            cl,     al        ; Get result in lsb of bl.
            xchg          al,     cl        ; Get result of both reads in al.
            cmp           al,     3         ; Check for error condition.
            je            fail              ; Fail if error has occured.
            cmp           al,     0         ; Check for disagreement.
            je            dis               ; Is there a disagreement on bus.
            xor           al,     1         ; No disagreement, write bit in al. 
            jmp           nodis             ; Go send the bit.
dis:
            mov           dl,     lc        ; Get rom loop counter in cl.
            cmp           dl,     ld        ; Compare current position w/ last.
            jg            slb               ; Before dis. from last search.
            jl            s0                ; If they are not equal send write 0.
            mov           al,     1         ; If equal send write 1 to bus.
            jmp           nodis             ; Don't save location of this dis.
s0:
            mov           al,     0         ; Clear al to indicate send write 0.
            jmp           saveloc           ; Go save location of this dis.
slb:                                            
            mov           al,     romdta[bx]; Get last bit in lsb of accumulator.
            and           al,     1         ; Save lsb to send to DOW bus.
            jnz           nodis             ; If bit is one don't save location.
saveloc:
            mov           l0,     dl        ; Save position of this disagreement.
nodis:
            call          touchbit          ; Send bit to part(s) on LPT #pn.
            mov           cl,     romdta[bx]; Get previous byte value in bl.
            mov           ch,     al        ; Get bit sent to LPT #pn in LSB of bh.
            shr           cx,     1         ; Shift new bit into msb of bl.
            mov           romdta[bx],cl     ; Save new byte value.
            dec           bptr     ec       ; Decrement eight counter.
            jnz           notbyte           ; Not a complete byte yet.
            inc           bx                ; Point to location for next byte.
            mov bptr      ec,   8           ; Reload eight counter.
notbyte:
            dec           bptr     lc       ; Decrement the loop counter variable.
            jnz           romloop           ; Have we gotten 64 bits yet?
            mov           al,      1        ; Indicate successful completion.
            mov           bl,      ld       ; Get last dis. from prev. src. in bl.
            cmp           bl,      l0       ; See if this was last part on bus.
            jne           success           ; If not leave.
            inc           al                ; Indicate this was last part.
            jmp           success           ; Leave.
fail:
            xor           al,      al       ; Set failure condition in ax.
success:    
            pop           cx                ; Restore cx register.
            pop           bx                ; Restore bx register.
            ret                             ; Return to caller.
romsrch     endp                            ; End of Rom Search procedure.        
;==============================================================================
; Access - access the part with romid in buffer romdta
;==============================================================================
ACCESS      proc          far               ; Procedure to access a DOW part.
            push          di                ; Save di register. 
            push          dx                ; Save callers dx register.
            push          cx                ; Save callers cx register.
            push          bx                ; Save callers bx register.
            call          glocate           ; Get offset of global var space in di.
            cmp bptr      setupok, 1        ; See if last call to setup succeeded.
            jne           accfail           ; Fail if it wasn't.
            mov bptr      accok,   0        ; If access fails don't do databyte.
            call          touchreset        ; Issue reset pulse.
            or            al,      al       ; Was a presence detected.
            jz            accfail           ; Fail if not.
            mov           ax,      0F0H     ; Get command byte in al.
            call          touchbyte         ; Send byte to LPT #pn.
            xor           bx,      bx       ; Zero bx register for indexing.
accloop:
            push          bx                ; Save our index register.
            xor           ah,      ah       ; Clear high byte of ax.
            mov           dh,     romdta[bx]; Get byte to send in al.
            mov           cx,      8        ; Initialize bit counter.
inloop:
            push          cx                ; Save bit counter.
            xor           dl,      dl       ; Clear low byte of dx.
            mov           al,      1        ; Send first 
            call          touchbit          ;    read time slot.
            mov           dl,      al       ; Get result in dl.
            shl           dl,      1        ; Adjust for next read time slot.
            mov           al,      1        ; Send second 
            call          touchbit          ;    read time slot.
            or            dl,      al       ; Combine with result of 1st slot.
            cmp           dl,      3        ; See if any parts still listening.
            je            accfail           ; Abort access if not.
            mov           al,      dh       ; Get current byte in al.
            and           al,      1        ; Clear all but lsb.
            shr           dh,      1        ; Adjust current byte.
            call          touchbit          ; Send write time slot.
            pop           cx                ; Restore bit counter.
            loop          inloop            ; Send all bits in this byte.
            pop           bx                ; Restore our index register.
            inc           bx                ; Point to next byte.
            cmp           bx,      8        ; Have we sent all 8 bytes.
            jne           accloop           ; Continue until all bytes sent.
            mov bptr      accok,   1        ; Access ok, don't block databyte.
            mov           ax,      1        ; Set success condition.
            jmp           skipfail          ; Don't clear al.
accfail:
            xor           ax,      ax       ; Clear al for failure condition.
skipfail:
            pop           bx                ; Restore callers bx register.
            pop           cx                ; Restore callers cx register.
            pop           dx                ; Restore callers dx register.
            pop           di                ; Restore data segment register.
            ret                             ; Return to caller.
ACCESS      endp                            ; End of access procedure. 
;==============================================================================
; Romdata - returns the data in the romdata buffer
;==============================================================================
ROMDATA     proc          far               ; Procedure to return ptr to Rom Data.
            push          di                ; Save callers di register.
            call          glocate           ; Get offset of globals in di.
            mov           dx,       cs      ; Get segment of romdta in dx. 
            mov           ax,       di      ; Get offset to top of globals in ax.
            add           ax,       20      ; Offset of romdta now in ax.
            pop           di                ; Restore callers di register.
            ret                             ; Return to caller.
ROMDATA     endp                            ; End of romdata procedure.         
;==============================================================================
; Setup - sets up the one wire port, sets the port address in the global portadr
;==============================================================================
SETUP       proc          far               ; Procedure to initialize LPT port.
            push          bp                ; Save callers base pointer on stack.
            mov           bp,      sp       ; Get stack pointer in base pointer.
            push          bx                ; Save bx register.
            push          di                ; Save callers di register. 
            call          glocate           ; Get offset of globals in di.
            mov bptr      portadr, 0        ; Get zero in port address to tell 
            mov bptr      setupok, 0        ; Start with failure condition.
            mov wptr      portadr, 0        ; Clear port address.
            call          getcnt            ; Get count value.
            mov           bl,      6[bp]    ; Get the LPT number.
            cmp           bl,      1        ; See if LPT number = 1.
            jne           not1              ; Branch if it doesn't.
            mov wptr      portadr, 0378H    ; Set port address.
            jmp           setupgd           ; Set happy flags.
not1:
            cmp           bl,      2        ; See if LPT number = 2.
            jne           not2              ; Branch what it ain't.
            mov wptr      portadr, 0278H    ; Set port address.
            jmp           setupgd           ; Set happy flags.
not2:
            cmp           bl,      3        ; See if LPT number = 3.
            jne           failstup          ; Fail setup if it isn't.
            mov wptr      portadr, 03BCH    ; Set port address.
setupgd:
            mov bptr      setupok, 1        ; Set setup success flag.
            mov           ax,      1        ; Success !
            jmp           succstup          ; Leave setup.
failstup:
            xor           ax,      ax       ; Indicate failure.
succstup:
            pop           di                ; Restore di register. 
            pop           bx                ; Restore bx register.
            pop           bp                ; Restore base pointer.
            ret           2                 ; Return to caller.
SETUP       endp                            ; End of setup procedure.
;==============================================================================
; Databyte - sends the byte passed in to the one-wire returns the data read 
;            from the one-wire
;==============================================================================
DATABYTE    proc         far                ; Procedure to send/receive data.
            push          bp                ; Save the base pointer.
            mov           bp,      sp       ; Get stack pointer in base pointer.
            push          di                ; Save callers di register.
            call          glocate           ; Get offset of globals in di.
            xor           ah,      ah       ; Zero high byte of ax.
            mov           al,      6[bp]    ; Get byte to send in al. 
            cmp bptr      setupok, 1        ; See if last call to setup succeeded.
            jne           dsbyte            ; If not don't send byte. 
            cmp bptr      accok,   1        ; See if last call to access succeeded. 
            jne           dsbyte            ; If not don't send byte.
            call          touchbyte         ; Send byte to LPT #pn.
dsbyte:
            pop           di                ; Restore data segment.
            pop           bp                ; Restore base pointer.
            ret           2                 ; Return to caller.
DATABYTE endp                           ; End of databyte procedure.
;==============================================================================
; Gndtest - returns true always
;==============================================================================
GNDTEST     proc          far               ; Procedure to bring input line high.
            push          di                ; Save callers di register.
            call          glocate           ; Get offset of globals in di.
            xor           ax,      ax       ; clear out the ax register
            mov           ax,      1        ; happy result
            pop           di                ; Restore callers globals. 
            ret                             ; Return to caller.
GNDTEST     endp                            ; End of gndtest procedure.
;==============================================================================
;
;    This procedure tells the DS1410D to issue a reset pulse and look for a
; presence detect signal. If a presece detect signal is issued by a 1-wire
; device, touchreset returns true (ax = 1). Otherwise touchreset returns false
; (ax = 0).
;
;
;    This procedure tells the DS1410D to issue a reset pulse and look for a
; presence detect signal. If a presece detect signal is issued by a 1-wire
; device, touchreset returns true (ax = 1). Otherwise touchreset returns false
; (ax = 0).
;==============================================================================
touchreset  proc
            push          bx                ; Restore callers bx register.
            mov           dx,      portadr
            mov           al,      0FDH
            call          do_comm 
            mov           dx,      portadr  ; Get the port address.
            mov           al,      0FDH     ; Indicate reset and supply power.
            call          do_comm           ; Go do the reset.
            xor           ax,      1        ; Result for DS1410E is inverted.
            pop           bx                ; Save callers bx register.
            ret                             ; Return to caller.
touchreset  endp
;==============================================================================
;         The TouchByte function transmits the byte in al to DS1410D on the
;         printer port, and returns as its value the byte received
;         concurrently from Pins 11, 13 of the printer port (each bit = 
;         11\ + 13). 
;==============================================================================
touchbyte   proc        
            push          bx                ; Save bx (romsrch index register).
            mov           cx,       8       ; Number of bits to send.
            xor           bx,       bx      ; Clear receive byte register.
LB1:        
            push          cx                ; Save loop counter.
            push          ax                ; Save current state of byte.
            call          touchbit          ; Transfer the data bit.
            rcr           al,       1       ; Get bit into carry.
            rcr           bl,       1       ; Get bit into bl.
            pop           cx                ; Get send character in cx.
            shr           cl,       1       ; Get next bit to send in cl.
            xchg          ax,       cx      ; Get send byte in ax.
            pop           cx                ; Restore counter.
            loop          LB1               ; Repeat until all bits sent/received.
            mov           al,       bl      ; Get byte received in al.
            xor           ah,       ah      ; Zero MS byte.
            pop           bx                ; Restore bx (romsrch index register). 
            ret                             ; Pop one parameter and return.
touchbyte   endp
;==============================================================================
;         The TouchBit function transmits the boolean value in al to the 
;         DS1410N on the printer port, and returns as its value the boolean 
;         value of the bit received concurrently from Pins 11, 13 of the 
;         printer port (bit = 11\ + 13).  
;==============================================================================
touchbit    proc         
            push          bx                ; Save bx (romsrch index register).
            push          dx                ; Save callers dx register.
            mov           dx,      portadr  ; Get the port address.
            test          al,      1        ; See if this is a write 0 time slot.
            jz            write0            ; Branch if it is.
            mov           al,      0FFH     ; D0 and D1 high read 0 or 1, write 1. 
            jmp           do_slot           ; Do bit time slot.
write0:
            mov           al,      0FEH     ; D0 low D1 high = write 0.
do_slot:
            call          do_comm           ; Go do the time slot.
            pop           dx                ; Restore callers dx register.
            pop           bx                ; Restore bx (romsrch index register). 
            ret                             ; Pop one parameter and return.
touchbit    endp
;==============================================================================
;    Spin around for 4 microseconds.
;==============================================================================
burn4us     proc      
            push          cx                ; Save callers cx register.
            mov           cx,        Count4 ; Get loop count in cx.
lf4:
            loop          lf4               ; Spin around for 4 usec. 
            pop           cx                ; Restore callers cx register.
            ret                             ; Return to caller.
burn4us     endp
;==============================================================================
;    Burn 16 ms to allow mode change in 7200E.
;==============================================================================
burn16ms    proc
            push          cx                ; Save callers cx register.
            mov           cx,    4000       ; 4000 * 4 us = 16 ms.
bms_1:
            call          burn4us           ; Spin around for 4 us.
            loop          bms_1             ; Keep waiting until cx = 0.
            pop           cx                ; Restore callers cx register.
            ret                             ; Return to caller.
burn16ms    endp
;==============================================================================
; Dowreset - calls touchreset to do a reset on the indicated onewire port
;==============================================================================
DOWRESET    proc          far
            push          di                ; save callers di register
            call          glocate           ; point to global variables
            call          touchreset        ; do the reset
            pop           di                ; restore callers di register
            ret
DOWRESET endp 
;==============================================================================
; ToggleOverdrive - toggles the state of overdrive on 1481 
;==============================================================================
ToggleOverdrive proc      far
            push          di                ; save callers di reg
            call          glocate           ; point to globals
            call          ToggleOD          ; do the toggleod
            pop           di                ; restore callers di reg
            ret     
ToggleOverdrive endp
;==============================================================================
;    Transmits overdrive toggle sequence to the DS1410E.
;==============================================================================
ToggleOD    proc                            
            push          cx                ; Save callers cx register.
            mov           dx,    portadr    ; Get the port address.
            pushf                           ; Save state of interrupts.
            cli                             ; Disable interrupts.
            mov           al,    0ECH       ; lower one control line if 14 grounded
            out           dx,    al         ; Set appropriate bits on data lines. 
            call          burn4us
            mov           al,    0FCH       ; Set appropriate bits on data lines
            out           dx,    al
            add           dx,    2          ; Point to pin 14.
            in            al,    dx         ; Read whats there.
            or            al,    04H
            and           al,    1CH        ; Mask write only bits.
            mov bptr      bpap2, al         ; Save bpa + 2 in global var space.
            or            al,    02H        ; Set p16 regardless of prev state. 
            out           dx,    al         ; Start communication !!!
            call          burn4us           ; Wait for devices to issue bsy signal.
            call          burn4us           ; Wait for devices to issue bsy signal.
            dec           dx                ; Point to control lines. 
            in            al,    dx         ; Read the result.
            xor           al,    80H        ; Flip value read on pin 11.
            test          al,    90H        ; Is either pin high?
            jz            tod_1             ; Branch if result = 0.
            mov           bx,    1          ; Result = 1. 
            jmp           tod_2             ; Restore port and return.
tod_1:
            xor           bx,     bx        ; Result = 0.         
tod_2:        
            push          bx
            call          burn4us
            call          burn4us
            inc           dx
            mov           al,bptr bpap2
            and           al,    0FDH
            out           dx,    al
            pop           bx
            xchg          ax,    bx         ; Get result in ax.
            push          ax
            mov           dx,    portadr
            mov           al,    0CFH
            out           dx,    al
            call          burn4us
            call          burn4us
            pop           ax
            popf                            ; Restore interrupts.
            pop           cx                ; Restore callers cx register.
            ret                             ; Return to caller.
ToggleOD endp
;==============================================================================
;    Toggle the passthru mode of any attached DS1410Es. 
;==============================================================================
TogglePT    proc
            push          cx
            push          di
            call          glocate
            mov           cx,    4          ; Send toggle overdrive 4 times.
tpt_1:                  
            call          ToggleOD          ; Send next overdrive toggle.
            loop          tpt_1             ; Send those overdrive toggles man.
            call          burn16ms          ; Screw around for 16 ms.
            pop           di 
            pop           cx
            ret                             ; Return to caller.
TogglePT endp
;==============================================================================
; CheckOd - check the state of overdrive
;==============================================================================
CHECKOD     proc          far
            push          di
            call          glocate
            pushf                           ; Save state of interrupts.
            cli                             ; Disable interrupts.
            mov           al,       0ECh    ; removes gnd printer problem
            mov           dx,       portadr ; point to the portaddress
            out           dx,       al      ; send the data to the port
            call          burn4us           ; wait awhile   
            mov           al,       0FFH
            out           dx,      al       ; Set appropriate bits on data lines. 
            call          burn4us
            add           dx,      2        ; Point to pin 14.
            in            al,      dx       ; Read whats there.
            and           al,      1CH      ; Mask write only bits.
            or            al,      6        ; Set p16 regardless of prev state. 
            mov bptr      bpap2,   al       ; Save bpa + 2 in global var space.
            out           dx,      al       ; Start communication !!!
            call          burn4us           ; Wait for devices to issue bsy signal.
            call          burn4us           ; Wait to drive clk high. 
            call          burn4us
            call          burn4us
            dec           dx                ; Point to 11 and 13.
            in            al,      dx       ; Read the result.
            xor           al,      80H      ; Flip value read on pin 11.
            test          al,      90H      ; Is either pin high?
            jnz           InOD              ; Branch if overdrive.
            mov           ax,      00H      ; Part not in Overdrive
            jmp           getbit11          ; finish time slot
InOD:
            mov           ax,      01H      ; Part in Overdrive
getbit11:
            push          ax
            dec           dx
            mov           al,      0FFH
            out           dx,      al
            inc           dx
            mov           cx, 0C8h
LL11:
            call          burn4us
            in            al,      dx
            xor           al,      80H
            dec           cx
            cmp           cx,      0
            je            LL12
            test          al,      90H
            jz            LL11              ; repeat until finished
LL12:
            dec           dx                ; point back to port address to get our bit
            mov           al,      0FEh     ; drive clk low to get our bit
            out           dx,      al
            call          burn4us
            inc           dx
            in            al,      dx
            inc           dx                ; point to control lines
            mov           al, bptr bpap2    ; write the original value back out
            and           al,      0FDh      
            out           dx,      al       ; put data out on register
            dec           dx                ; point back to data lines
            dec           dx
            mov           al,      0CFH     ; drive at least one of the data lines low
                
            out           dx,      al       ; drive line low
            call          burn4us
            
            pop           ax
            mov           cx,      ax
            popf
            pop           di
            ret
CHECKOD     endp
;==============================================================================
;    Exit passthru mode.
;==============================================================================
ExitPT      proc
            push          di
            call          glocate
            mov           cx, 3             ; Try to toggle passthru 3 times.
ept_1:
            push          cx
            call          TogglePT
            call          ChkBrick
            jc            ept_2             ;cx has to be poped
            pop           cx
            loop          ept_1
            mov           cx, 0   
            jmp           ept_3
ept_2:                  
            pop           cx
            mov           cx,    1
ept_3:                  
            push          ax
            push          cx
            call          checkod           ; check to see if part is in overdrive
            cmp           cx,    1          ; 
            jne           DonePT            ; if not overdrive, exit
            call          ExitOD            ; if in overdrive, exit overdrive
DonePT:                 
            pop           cx
            pop           ax
            pop           di
            ret                             ; Return to caller.
ExitPT      endp
;==============================================================================
;ExitOD - Take 1481 out of overdrive
;==============================================================================
ExitOD      proc
            push          ax
            push          cx
            push          di
            call          glocate
            mov           ax, 0
;                         call     burn4us
            call          ToggleOD
            cmp           ax,         1     ; See if we toggled out of OD
            jne            NoTogOD
            call          ToggleOD
NoTogOD:                  
            pop           di
            pop           cx
            pop           ax
            ret
ExitOD      endp
;==============================================================================
; ChkBrick - check for the presence of a brick
;==============================================================================
ChkBrick    proc
            push          cx
            mov           dx,        portadr
            mov           al,        0FDh
            call          do_comm
            mov           al,        0FFh
            call          do_chkcomm
            cmp           ax,        1
            je            cb_a1
            clc           
            jmp           cb_a2
cb_a1:                    
            stc           
cb_a2:                    
            pop           cx
            ret
ChkBrick    endp
;==============================================================================
; getcnt - do the timing setup
;==============================================================================
getcnt  proc         
            push          bx                ; Save callers bx register. 
            push          cx                ; Save callers cx register.
            push          dx                ; Save callers dx register.
            mov           cx,       1       ; Prepare to measure offset.
            pushf                           ; Save the state of interrupts.
            cli                             ; Inhibit all interrupts.
            call          Timit             ; Measure constant offset.
            push          ax                ; Save constant on stack.
            mov           cx,       2049    ; Get the loop count value.
            call          Timit             ; Measure the total time.
            pop           bx                ; Retrieve the constant part.
            popf                            ; Restore interrupts.
            sub           ax,       bx      ; AX = Time for 2048 loops.
            mov           bx,       ax      ; Get divisor in bx.
            mov           dx,       4       ; Dividend DX:AX = 312785
            mov           ax,       0C5D1H  ;    = 2.38636 * 64 * 2048.
            div           bx                ; Quotient in AX, rem in DX.
            inc           ax                ; Round up to nearest integer.
            mov           cx,       ax      ; Get time calibration.
            shr           cx,       1       ; Divide counts by
            shr           cx,       1       ;    16 to get 
            shr           cx,       1       ;       4 usec
            shr           cx,       1       ;          delay.
            mov           Count,    cx      ; Store result in Count.
            mov           Count4,   cx      ; Store in global.
            pop           dx                ; Restore callers dx register. 
            pop           cx                ; Restore callers cx register.
            pop           bx                ; Restore callers bx register.
            ret                             ; Return to caller.
getcnt      endp
;

;==============================================================================
; do_comm - do the one-wire processing.  Same as ds1481comm in sauth400.c
;==============================================================================
do_comm     proc       
            pushf                           ; Save state of interrupts.
            cli                             ; Disable interrupts.
            mov           dx,       portadr
            mov bptr      DRegByte, al      ; save the byte being sent out
            mov           al,      0ECh
            out           dx,      al       ; if 14 is gnd the set 1 pwr pin low to enable the device
            call          burn4us           ; waste a little time
            mov           al, bptr DRegByte ; get the data ready to send out 
            out           dx,      al       ; Set appropriate bits on data lines. 
            add           dx,      2        ; Point to pin 14.
            in            al,      dx       ; Read whats there.
            and           al,      1CH      ; Mask write only bits.
            or            al,      6        ; Set p16 regardless of prev state. 
            mov bptr      bpap2,   al       ; Save bpa + 2 in global var space.
            out           dx,      al       ; Start communication !!!
            call          burn4us           ; Wait for devices to issue bsy signal.
            dec           dx
            in            al,      dx       ; read the busy lines  
            popf                            ; Restore interrupts
            call          burn4us           ; Wait to drive clk high. 
            mov           al,      0FFH     ; Now we can drive all data lines
            dec           dx                ; point to supply lines
            out           dx,      al       ;       of our supply.
            inc           dx                ; Point to 11 and 13.
            mov           cx,      100      ; Time out loop var.
ww_busy:                
            call          burn4us           ; Wait while part is busy. 
            in            al,      dx       ; Read the result.
            xor           al,      80H      ; Flip value read on pin 11.
            test          al,      90H      ; Is either pin high?
            jnz           getbit            ; Branch if not busy.
            loop          ww_busy           ; Keep waiting for bsy inactive.
getbit:                 
            dec           dx                ; Point to data lines.
            mov           al,      0FEH     ; Get ready to drive clk line low.
            out           dx,      al       ; Drive clk line low.
            call          burn4us           ; Wait for valid bit result.
            inc           dx                ; Point to pins 11, 13.
            in            al,      dx       ; Read the result.
            xor           al,      80H      ; Flip value read on pin 11.
            test          al,      90H      ; Is either pin high?
            jz            was_low           ; Branch if result = 0.
            mov           al,bptr  DRegByte ; Get the byte we sent out
            cmp           al,      0FDH     ; is it a reset
            jne           not_res           ; jump if not a reset
            mov           cx,      125      ; need to burn 400us
R1:                     
            call          burn4us           ; spin on burn 4us until 
            loop          R1
            mov           al,      0FFH     ; byte to send out
            dec           dx                ; back to portadr
            out           dx,      al       ; send the byte
            call          burn4us           ; wait 4 us
            mov           al,      0FEH     ; drive clk low to get our bit
            out           dx,      al
            call          burn4us           ; wait 4 us
            inc           dx                ; Point to pins 11, 13.
            in            al,      dx       ; Read the result.
            xor           al,      80H      ; Flip value read on pin 11.
            test          al,      90H      ; Is either pin high?
            jz            was_low           ; Branch if result = 0.
                        
not_res:                
            mov           bx,      1        ; Result = 1. 
            jmp           res_ret           ; Restore port and return.
was_low:                
            xor           bx,      bx       ; Result = 0.         
res_ret:                
            mov           al, bptr bpap2    ; Get value to restore to BPA + 2.
            and           al,      0FDH     ; Set 14 back high.
            inc           dx                ; Point to PA+2.
            out           dx,      al       ; Restore PA+2, make sure 14, 16 high.
            push          bx
            sub           dx,      2
            mov           al,      0CFh
            out           dx,      al
            call          burn4us
            call          burn4us
            call          burn4us
            pop           bx
            xchg          ax,      bx       ; Get result in ax.
            ret                             ; Return to caller.
do_comm     endp
;==============================================================================
; do_chkcomm - checks for the presence of a 1481.  Returns the state
;              of the busy lines.  1481 is present if busy lines
;              change state and there isn't a timeout
;==============================================================================
do_chkcomm proc       
            pushf                           ; Save state of interrupts.
            cli                             ; Disable interrupts.
            mov bptr      DRegByte,   al 
            mov           al,        0ECh
            out           dx,        al
            call          burn4us           ; waste a little time
            mov           al, bptr DRegByte ; restore the byte to be sent
            out           dx,        al     ; Set appropriate bits on data lines. 
            add           dx,        2      ; Point to pin 14.
            in            al,        dx     ; Read whats there.
            and           al,        1CH    ; Mask write only bits.
            or            al,        6      ; Set p16 regardless of prev state. 
            mov bptr      bpap2,     al     ; Save bpa + 2 in global var space.
            out           dx,        al     ; Start communication !!!
            call          burn4us           ; Wait for devices to issue bsy signal.
            popf                            ; Restore interrupts
            call          burn4us           ; Wait to drive clk high. 
            dec           dx                ; point to busy lines
            in            al,        dx     
            mov           al,        0FFH   ; Now we can drive all data lines
            dec           dx                ;    high to get the most out
            out           dx,        al     ;       of our supply.
            inc           dx                ; Point to 11 and 13.
            mov           cx,        100    ; Time out loop var.
ww_nbusy1:               
            in            al,        dx     ; read the result
            xor           al,        80H    ; Flip value read on pin11
            test          al,        90H    ; Is either pin high?
            jz            ww_busy1          ; No, then both went low
            call          burn4us           ; burn some time
            loop          ww_nbusy1
            mov           cx,        0      ; No brick
            jmp           getbit1           ; busy lines failed to go low.
ww_busy1:                
            call          burn4us           ; Wait while part is busy. 
            in            al,        dx     ; Read the result.
            xor           al,        80H    ; Flip value read on pin 11.
            test          al,        90H    ; Is either pin high?
            jnz           BrickPres         ; Branch if not busy.
            loop          ww_busy1          ; Keep waiting for bsy inactive.
            mov           cx,        0      ; No brick timed out
            jmp           getbit1
BrickPres:               
            mov           cx,        1
                         
getbit1:                 
            push          cx
            dec           dx 
            mov           al,        0FEh   ; point to data reg
            out           dx,        al     ; drive clk back high
            call          burn4us
            inc           dx
            in            al,        dx     ; don't care about the result
            call          burn4us
            mov           al, bptr   bpap2  ; Get value to restore to BPA + 2.
            and           al,        0FDH   ; Set 14 back high.
            inc           dx                ; Point to PA+2.
            out           dx,        al     ; Restore PA+2, make sure 14, 16 high.
            sub           dx,        2
            mov           al,        0CFH
            out           dx,        al
            call          burn4us
            call          burn4us
            call          burn4us
            pop           cx
            mov           ax,        cx
            ret                             ; Return to caller.
do_chkcomm  endp
;==============================================================================
; Timit - function to burn time.  Burns the number of cycles passed in cx
;==============================================================================
Timit       proc        
            mov           al,       0       ; Load the freeze command.
            out           43H,      al      ; Freeze the initial count.
            in            al,       40H     ; Get LS byte of count.
            mov           bl,       al      ; Save LS count byte.
            in            al,       40H     ; Get MS byte of count.
            mov           bh,       al      ; Initial count now in BX.
L:                                         
            loop          L                 ; Count up to CX.
            mov           al,       0       ; Load the freeze command.
            out           43H,      al      ; Freeze the final count.
            in            al,       40H     ; Get LS byte of count.
            mov           ah,       al      ; Save LS count byte.
            in            al,       40H     ; Get MS byte of count.
            xchg          al,       ah      ; Final count now in AX.
            xchg          ax,       bx      ; Position data to subtract.
            sub           ax,       bx      ; Count difference now in AX.
            ret                             ; Return.
Timit       endp
;
code        ends
end




